import * as cc from 'cc'
import { I18n } from 'tools-cocos3x'
const { ccclass } = cc._decorator

/**
 * 在顶级节点使用，注册多语言节点
 */
@ccclass
export default class CI18n extends cc.Component {
    id: string = null!
    onLoad() {
        this.id = I18n.on(this.node)
    }
    onDestroy() {
        I18n.off(this.id)
    }
}
