System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, AudioSource, Node, Res, SoundBean, _crd;

  function _reportPossibleCrUseOfRes(extras) {
    _reporterNs.report("Res", "./Res", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      __checkObsolete__ = _cc.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc.__checkObsoleteInNamespace__;
      AudioSource = _cc.AudioSource;
      Node = _cc.Node;
    }, function (_unresolved_2) {
      Res = _unresolved_2.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "2e7c1wdVW9HAY37DxDsZVOG", "SoundBean", undefined);

      __checkObsolete__(['AudioClip', 'AudioSource', 'Node']);

      _export("default", SoundBean = class SoundBean {
        constructor() {
          this.node = null;
          this.audioSource = null;
          this.startedFun = null;
          this.endedFun = null;
          this.id = null;
          this.param = null;
        }

        setConfig(param) {
          this.param = param;
          const {
            bundleName,
            musicName,
            volume
          } = this.param;
          this.id = StrUtil.getId();
          let soundUrl1 = 'sound/' + musicName;
          const clip = (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
            error: Error()
          }), Res) : Res).getAsset(bundleName, soundUrl1);
          this.node = new Node();
          this.audioSource = this.node.addComponent(AudioSource);
          this.setClip(clip);
          this.setVolume(volume);
          this.audioSource.node.on(AudioSource.EventType.STARTED, this.onAudioStarted, this);
          this.audioSource.node.on(AudioSource.EventType.ENDED, this.onAudioEnded, this);
        }

        onAudioStarted() {
          if (this.startedFun) this.startedFun();
        }

        onAudioEnded() {
          if (this.endedFun) this.endedFun();

          if (this.param.loop) {
            this.play();
          }
        }

        play() {
          this.audioSource.play();
        }
        /**
         * stop the audio play
         */


        stop() {
          this.audioSource.stop();
        }
        /**
         * pause the audio play
         */


        pause() {
          this.audioSource.pause();
        }
        /**
         * resume the audio play
         */


        resume() {
          this.play();
        }

        setClip(clip) {
          this.audioSource.clip = clip;
        }

        setVolume(volume) {
          this.audioSource.volume = volume;
        }

        destroy() {
          this.setVolume(0);
          this.audioSource.node.off(AudioSource.EventType.STARTED, this.onAudioStarted, this);
          this.audioSource.node.off(AudioSource.EventType.ENDED, this.onAudioEnded, this);
          this.node.removeFromParent();
          this.node.destroy();
        }

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=1d451446b814e98dca4e100398e791dc5b63503b.js.map