System.register(["__unresolved_0", "cc", "__unresolved_1", "__unresolved_2"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _cc, Cocos3x, Res, Ci18n, _crd, cc;

  function _reportPossibleCrUseOfCocos3x(extras) {
    _reporterNs.report("Cocos3x", "./Cocos3x", _context.meta, extras);
  }

  function _reportPossibleCrUseOfRes(extras) {
    _reporterNs.report("Res", "./Res", _context.meta, extras);
  }

  _export("Ci18n", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }, function (_unresolved_2) {
      Cocos3x = _unresolved_2.Cocos3x;
    }, function (_unresolved_3) {
      Res = _unresolved_3.Res;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "4bedfj32UpKRrGHax/KTr3o", "Ci18n", undefined);

      cc = __checkObsoleteInNamespace__(_cc);

      /**
       * 国际化管理
       * @param label 文本：在label上写入的值对应json的key
       * @param plist 图片：对应语言的plist、png后缀如：_zh、_en等
       * @param audio 音频：对应语言的mp3后缀如：_zh、_en等
       * @param skeleton 骨骼动画：对应语言的json、atlas、png后缀如：_zh、_en等
       */
      _export("Ci18n", Ci18n = class Ci18n {
        /** 初始化国际化配置 */
        static init(config) {
          /** 处理添加动态节点国际化 */
          Object.defineProperty(cc.Node.prototype, 'addChild', {
            value: function (child) {
              Ci18n.setNodeLang(child); // @ts-ignore

              child.setParent(this);
            }
          });
          /** 重写加载方法，处理动态prefab国际化 */
          //@ts-ignore

          const _load = cc.assetManager.packManager.load;

          cc.assetManager.packManager.load = function (item, options, onComplete) {
            const _onComplete = onComplete;

            onComplete = (err, data) => {
              if (Ci18n.lang !== Ci18n.defaultLang) {
                var _item$info;

                //@ts-ignore
                const isPrefab = ((_item$info = item.info) == null ? void 0 : _item$info.ctor) == cc.Prefab;

                if (isPrefab) {
                  const findLangId = (path, type) => {
                    return Object.keys(Ci18n.resMap).find(key => Ci18n.resMap[key].path == path && Ci18n.resMap[key].ctor == type);
                  };

                  const fun = {
                    'Sprite': el => {
                      let _uuid = el._spriteFrame.__uuid__ || el._spriteFrame.uuid;

                      if (_uuid) {
                        const _info = Ci18n.resMap[_uuid];

                        if (_info) {
                          if (_info.path.endsWith('/spriteFrame')) {
                            const _sp = _info.path.split('/spriteFrame');

                            _uuid = findLangId(_sp[0] + '_' + Ci18n.lang + '/spriteFrame', cc.SpriteFrame);
                          } else {
                            const psfurl1 = _info.path.substring(0, _info.path.lastIndexOf('/'));

                            const psfurl2 = _info.path.substring(_info.path.lastIndexOf('/'));

                            _uuid = findLangId(psfurl1 + '_' + Ci18n.lang + psfurl2, cc.SpriteFrame);
                          }

                          el._spriteFrame.uuid = _uuid;
                          el._spriteFrame.__uuid__ = _uuid;
                        }
                      }

                      return el;
                    },
                    'Skeleton': el => {
                      let _uuid = el._skeletonData.__uuid__ || el._skeletonData.uuid;

                      if (_uuid) {
                        const _info = Ci18n.resMap[_uuid];

                        if (_info) {
                          _uuid = findLangId(_info.path + '_' + Ci18n.lang, cc.sp.SkeletonData);
                          el._skeletonData.__uuid__ = _uuid;
                          el._skeletonData.uuid = _uuid;
                        }
                      }

                      return el;
                    }
                  };

                  if (Array.isArray(data)) {
                    for (let j = 0; j < data.length; j++) {
                      const el = data[j];

                      if (el._spriteFrame) {
                        fun['Sprite'](el);
                      } else if (el._skeletonData) {
                        fun['Skeleton'](el);
                      }
                    }
                  }
                }
              }

              _onComplete(err, data);
            }; //@ts-ignore


            return _load.call(cc.assetManager.packManager, item, options, onComplete);
          };

          Ci18n.lang = config.lang;
          Ci18n.defaultLang = config.defaultLang;
          Ci18n.langList = config.langList.map(item => '_' + item);
        }
        /** 注册国际化节点 */


        static on(node) {
          const id = StrUtil.uuid();
          Ci18n.map[id] = node;
          Ci18n.setNodeLang(node);
          return id;
        }
        /** 注销国际化节点 */


        static off(id) {
          delete Ci18n.map[id];
        }
        /** 注销所有国际化节点 */


        static clear() {
          Ci18n.map = {};
        }
        /** 获取多语言文本配置，可自定义配置获取方式，默认使用http获取 */


        static async getLangJson(lang) {
          try {
            if (Ci18n.langJson[lang]) return Ci18n.langJson[lang];
            let res = await http.get({
              url: '/lang/' + lang + '.json',
              timeout: 5000
            });
            if (typeof res === 'string') res = JSON.parse(res);
            Ci18n.langJson[lang] = res;
            return res;
          } catch (error) {
            return undefined;
          }
        }
        /** 设置国际化节点 */


        static async setNodeLang(node) {
          const updateNodeLang = async child => {
            const text = child.getComponent(cc.Label);
            const sprite = child.getComponent(cc.Sprite);
            const audioSource = child.getComponent(cc.AudioSource);
            const skeleton = child.getComponent(cc.sp.Skeleton);

            try {
              if (text) {
                if (!Ci18n.sourceMap[child.uuid]) Ci18n.sourceMap[child.uuid] = {
                  text: text.string
                };
                let _text = Ci18n.sourceMap[child.uuid].text;
                const langJson = await Ci18n.getLangJson(Ci18n.lang);

                if (langJson) {
                  const val = ObjectUtil.getPathValue(langJson, _text);
                  if (val !== text.string) text.string = val;
                }
              }

              if (sprite) {
                var _sprite$spriteFrame;

                const _uuid = (_sprite$spriteFrame = sprite.spriteFrame) == null ? void 0 : _sprite$spriteFrame.uuid;

                const info = Ci18n.resMap[_uuid];

                if (info) {
                  let _path = info.path.split('/spriteFrame')[0];

                  if (!Ci18n.sourceMap[child.uuid]) {
                    const _info = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                      error: Error()
                    }), Cocos3x) : Cocos3x).Ci18n.pathInList(_path);

                    if (_info.status) _path = _path.replace((_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                      error: Error()
                    }), Cocos3x) : Cocos3x).Ci18n.langList[_info.index], '');
                    Ci18n.sourceMap[child.uuid] = {
                      text: _path
                    };
                  }

                  let _text = Ci18n.sourceMap[child.uuid].text; //获取plist下的spriteFrame

                  let psfurl = _text.split('/spriteFrame')[0];

                  const psfurl1 = psfurl.substring(0, psfurl.lastIndexOf('/'));
                  const psfurl2 = psfurl.substring(psfurl.lastIndexOf('/'));
                  if (Ci18n.lang !== Ci18n.defaultLang) psfurl = psfurl1 + '_' + Ci18n.lang + psfurl2;

                  const _pssf = await (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                    error: Error()
                  }), Res) : Res).getAsset(psfurl, cc.SpriteFrame, info.bundleName);

                  if (_pssf instanceof cc.SpriteFrame) {
                    sprite.spriteFrame = _pssf;
                  } else {
                    //尝试获取图片下的spriteFrame
                    let _pathres = _text.split('/spriteFrame')[0];

                    if (Ci18n.lang !== Ci18n.defaultLang) {
                      _pathres += '_' + Ci18n.lang;
                    }

                    _pathres += '/spriteFrame';

                    const _spriteFrame = await (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                      error: Error()
                    }), Res) : Res).getAsset(_pathres, cc.SpriteFrame, info.bundleName);

                    if (_spriteFrame instanceof cc.SpriteFrame) sprite.spriteFrame = _spriteFrame;
                  }
                }
              }

              if (audioSource) {
                var _audioSource$clip;

                const _uuid = (_audioSource$clip = audioSource.clip) == null ? void 0 : _audioSource$clip.uuid;

                const info = Ci18n.resMap[_uuid];

                if (info) {
                  let _path = info.path;

                  if (!Ci18n.sourceMap[child.uuid]) {
                    const _info = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                      error: Error()
                    }), Cocos3x) : Cocos3x).Ci18n.pathInList(_path);

                    if (_info.status) _path = _path.replace((_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                      error: Error()
                    }), Cocos3x) : Cocos3x).Ci18n.langList[_info.index], '');
                    Ci18n.sourceMap[child.uuid] = {
                      text: _path
                    };
                  }

                  let _text = Ci18n.sourceMap[child.uuid].text;

                  if (Ci18n.lang !== Ci18n.defaultLang) {
                    _text += '_' + Ci18n.lang;
                  }

                  const _clip = await (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                    error: Error()
                  }), Res) : Res).getAsset(_text, cc.AudioClip, info.bundleName);

                  if (_clip) audioSource.clip = _clip;
                }
              }

              if (skeleton) {
                var _skeleton$skeletonDat;

                const _uuid = (_skeleton$skeletonDat = skeleton.skeletonData) == null ? void 0 : _skeleton$skeletonDat.uuid;

                const info = Ci18n.resMap[_uuid];

                if (info) {
                  let _path = info.path;

                  if (!Ci18n.sourceMap[child.uuid]) {
                    const _info = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                      error: Error()
                    }), Cocos3x) : Cocos3x).Ci18n.pathInList(_path);

                    if (_info.status) _path = _path.replace((_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                      error: Error()
                    }), Cocos3x) : Cocos3x).Ci18n.langList[_info.index], '');
                    Ci18n.sourceMap[child.uuid] = {
                      text: _path
                    };
                  }

                  let _text = Ci18n.sourceMap[child.uuid].text;

                  if (Ci18n.lang !== Ci18n.defaultLang) {
                    _text += '_' + Ci18n.lang;
                  }

                  const _skeletonData = await (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                    error: Error()
                  }), Res) : Res).getAsset(_text, cc.sp.SkeletonData, info.bundleName);

                  if (_skeletonData) {
                    const _aniName = skeleton.animation;
                    const _loop = skeleton.loop;
                    skeleton.skeletonData = _skeletonData;
                    skeleton.setAnimation(0, _aniName, _loop);
                  }
                }
              }
            } catch (error) {
              console.log('error', error);
            }

            for (let i = 0; i < child.children.length; i++) {
              const _child = child.children[i];
              updateNodeLang(_child);
            }
          };

          updateNodeLang(node);
        }
        /** 默认开发语言-不带后缀 */


        /** 由Res调用加载资源映射 */
        static loadResMap(key) {
          var _bundleMap$key$_confi;

          // @ts-ignore
          const map = (_bundleMap$key$_confi = (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
            error: Error()
          }), Res) : Res).bundleMap[key]._config) == null || (_bundleMap$key$_confi = _bundleMap$key$_confi.assetInfos) == null ? void 0 : _bundleMap$key$_confi._map;

          if (map) {
            Object.keys(map).forEach(_key => {
              Ci18n.resMap[_key] = { ...map[_key],
                bundleName: key
              };
            });
          }
        }
        /** 设置语言 */


        static async setLang(lang) {
          if (Ci18n.lang === lang) return;
          Ci18n.lang = lang;
          const keys = Object.keys(Ci18n.map);

          for (let i = 0; i < keys.length; i++) {
            const key = keys[i];
            Ci18n.setNodeLang(Ci18n.map[key]);
          }
        }
        /** 判断路径是否包含语言后缀 */


        static pathInList(path) {
          const langList = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
            error: Error()
          }), Cocos3x) : Cocos3x).Ci18n.langList;

          for (let i = 0; i < langList.length; i++) {
            if (path.indexOf(langList[i]) !== -1) {
              return {
                status: true,
                index: i
              };
            }
          }

          return {
            status: false,
            index: -1
          };
        }

      });

      /**
       * 语言json
       */
      Ci18n.langJson = {};

      /** 国际化节点 */
      Ci18n.map = {};

      /** 国际化节点原始数据 */
      Ci18n.sourceMap = {};
      Ci18n.defaultLang = 'en';

      /** 当前语言 */
      Ci18n.lang = 'en';

      /**
       * 支持的语言列表
       */
      Ci18n.langList = [];

      /** 资源数据备份 */
      Ci18n.resMap = {};
      (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
        error: Error()
      }), Cocos3x) : Cocos3x).Ci18n = Ci18n;

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=347f6a60338765f84b525e59e16ca114b995eedc.js.map