System.register(["__unresolved_0", "cc", "tools-cocos38", "__unresolved_1", "__unresolved_2", "__unresolved_3"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, fgui, i18n, ApiHilo, ConfigUtil, btnSer, _crd, initPlayBtn, getPlayDisable;

  function _reportPossibleCrUseOfi18n(extras) {
    _reporterNs.report("i18n", "../../../utils/i18n", _context.meta, extras);
  }

  function _reportPossibleCrUseOfhomeSer(extras) {
    _reporterNs.report("homeSer", "../homeSer", _context.meta, extras);
  }

  function _reportPossibleCrUseOfApiHilo(extras) {
    _reporterNs.report("ApiHilo", "../../../api/ApiHilo", _context.meta, extras);
  }

  function _reportPossibleCrUseOfConfigUtil(extras) {
    _reporterNs.report("ConfigUtil", "../../../utils/ConfigUtil", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }, function (_toolsCocos) {
      fgui = _toolsCocos;
    }, function (_unresolved_2) {
      i18n = _unresolved_2.default;
    }, function (_unresolved_3) {
      ApiHilo = _unresolved_3.default;
    }, function (_unresolved_4) {
      ConfigUtil = _unresolved_4.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "5738favprpGOpkci1xcubnc", "btnSer", undefined);

      /**
       * 设置play按钮样式
       * @param _btn
       * @param param
       */
      initPlayBtn = (_btn, param) => {
        const _BtnCom = _btn.getChild('bg', fgui.GComponent);

        if (param.status !== undefined) _BtnCom.getController('status').selectedIndex = param.status;
        if (param.icon !== undefined) _BtnCom.getController('icon').selectedIndex = param.icon;
        if (param.disable !== undefined) _BtnCom.getController('disable').selectedIndex = param.disable;
        if (param.theme !== undefined) _BtnCom.getController('theme').selectedIndex = param.theme;
        if (param.text !== undefined) _BtnCom.getChild('icon-right', fgui.GTextField).text = param.text;
      };

      getPlayDisable = _btn => {
        const _BtnCom = _btn.getChild('bg', fgui.GComponent);

        return _BtnCom.getController('disable').selectedIndex == 1;
      };

      _export("default", btnSer = class btnSer {
        constructor(homeSer) {
          this.bottomView = null;
          this.betamount = null;
          this.xiaBtn = null;
          this.shangBtn = null;
          this.btnv1 = null;
          this.btnv20 = null;
          this.btnv50 = null;
          this.btnv100 = null;
          this.btnnum0 = null;
          this.btnnum1 = null;
          this.startBtn = null;
          this.skipBtn = null;
          this.endBtn = null;
          this.lineBtn = null;
          this.moreBtn = null;
          this.moreHideBtn = null;
          this.historyBtn = null;
          this.ruleBtn = null;
          this.musicBtn = null;
          this.langBtn = null;

          this.showPlayBtn = show => {
            initPlayBtn(this.xiaBtn, {
              disable: show ? 0 : 1
            });
            initPlayBtn(this.shangBtn, {
              disable: show ? 0 : 1
            });
          };

          this.addHistoryItem = async (prs, end) => {
            if (prs.length == 1) {
              this.homeSer.historySer.list.numItems = 0;
            }

            const prItem = prs[prs.length - 1]; //获取游戏结果

            const _res = {
              status: prItem.status,
              score: prItem.ratio + 'X',
              num: prItem.pokers[0] + '',
              color: prItem.pokers[1]
            };

            if (this.homeSer.historySer.list.numItems === 0) {
              this.homeSer.historySer.addItem(_res);
              await this.homeSer.aniSer.cardShow(_res);
            } else {
              await this.homeSer.aniSer.moveTop();
              await this.homeSer.aniSer.cardShow(_res);
              this.homeSer.historySer.addItem(_res);

              if (end) {
                await this.homeSer.aniSer.cardFail();
              }
            }

            (_crd && ConfigUtil === void 0 ? (_reportPossibleCrUseOfConfigUtil({
              error: Error()
            }), ConfigUtil) : ConfigUtil).isAniEnd = true; //将按钮设置为具体的值

            this.homeSer.valSer.setCS(prItem.cardBetInfo);
          };

          this.setDisbale = (_btn, disbale) => {
            _btn.getChild('bg', fgui.GComponent).getController('disable').selectedIndex = disbale ? 1 : 0;
          };

          this.showValBtns = show => {
            this.setDisbale(this.btnv1, !show);
            this.setDisbale(this.btnv20, !show);
            this.setDisbale(this.btnv50, !show);
            this.setDisbale(this.btnv100, !show);
            this.setDisbale(this.btnnum0, !show);
            this.setDisbale(this.btnnum1, !show);
          };

          this.initPlayInfo = async () => {
            const pinfo = (_crd && ConfigUtil === void 0 ? (_reportPossibleCrUseOfConfigUtil({
              error: Error()
            }), ConfigUtil) : ConfigUtil).playerInfo;

            if (pinfo) {
              this.showValBtns(false);
              const prs = pinfo.previousRolls;
              this.showPlayBtn(true);
              this.bottomView.getController('GameStatus').selectedIndex = 1;

              for (let i = 0; i < prs.length; i++) {
                const prItem = prs[i];
                const _res = {
                  status: prItem.status,
                  score: prItem.ratio + 'X',
                  num: prItem.pokers[0] + '',
                  color: prItem.pokers[1]
                };

                if (i !== prs.length - 1) {
                  this.homeSer.historySer.addItem(_res);
                } else {
                  this.homeSer.historySer.addItem(_res);
                  await this.homeSer.aniSer.cardShow(_res);
                  this.homeSer.valSer.setCS(prItem.cardBetInfo);
                }
              }

              this.homeSer.valSer.setPanelVal({
                balance: (_crd && ConfigUtil === void 0 ? (_reportPossibleCrUseOfConfigUtil({
                  error: Error()
                }), ConfigUtil) : ConfigUtil).userInfo.balance,
                playerInfo: pinfo
              });
            } else {
              this.showValBtns(true);
            }
          };

          this.clickTime = 0;
          this.clickLastItem = null;

          this.onClick = (btn, callback) => {
            btn.onClick(() => {
              const thisTime = Date.now(); //阻止事件传递、多点触摸？

              if (thisTime - this.clickTime < 20) {
                return;
              }

              this.clickTime = thisTime;
              const mlCon = this.homeSer.mainView.getController('MoreList');
              if (mlCon.selectedIndex == 1) mlCon.selectedIndex = 0;
              if (callback) callback();
            });
          };

          this.homeSer = homeSer;
          this.initBtn();
        }

        /**
         * 初始化按钮样式
         */
        initBtn() {
          const bottomView = this.homeSer.mainView.getChild('bottomView', fgui.GComponent);
          this.bottomView = bottomView;
          this.onClick(this.homeSer.mainView);
          this.betamount = bottomView.getChild('betamount', fgui.GTextField);
          (_crd && i18n === void 0 ? (_reportPossibleCrUseOfi18n({
            error: Error()
          }), i18n) : i18n).on(this.betamount);
          const balanceText = bottomView.getChild('balanceText', fgui.GTextField);
          (_crd && i18n === void 0 ? (_reportPossibleCrUseOfi18n({
            error: Error()
          }), i18n) : i18n).on(balanceText); //------底部按钮

          const playGame = async isBig => {
            (_crd && ConfigUtil === void 0 ? (_reportPossibleCrUseOfConfigUtil({
              error: Error()
            }), ConfigUtil) : ConfigUtil).aniTask(async () => {
              const res = await (_crd && ApiHilo === void 0 ? (_reportPossibleCrUseOfApiHilo({
                error: Error()
              }), ApiHilo) : ApiHilo).start({
                optType: 1,
                isBig
              });
              const isEnd = res.data.loseMoney === -1;

              if (isEnd) {
                endGame();
              }

              await this.addHistoryItem(res.data.playerInfo.previousRolls, isEnd);
              this.homeSer.valSer.setPanelVal(res.data);
            });
          };

          const endGame = () => {
            this.showPlayBtn(false);
            this.bottomView.getController('GameStatus').selectedIndex = 0;
            this.showValBtns(true);
          };

          this.xiaBtn = bottomView.getChild('xiaBtn', fgui.GButton);
          this.onClick(this.xiaBtn, async () => {
            if (getPlayDisable(this.xiaBtn)) return;
            playGame(false);
          });
          initPlayBtn(this.xiaBtn, {
            status: 0,
            icon: 1,
            theme: 0,
            text: 'LO'
          });
          this.shangBtn = bottomView.getChild('shangBtn', fgui.GButton);
          this.onClick(this.shangBtn, async () => {
            if (getPlayDisable(this.shangBtn)) return;
            playGame(true);
          });
          initPlayBtn(this.shangBtn, {
            status: 1,
            icon: 1,
            theme: 1,
            text: 'HI'
          });
          this.showPlayBtn(false);

          const initMoneyBtn = (name, text) => {
            const _btn = bottomView.getChild(name, fgui.GButton);

            const _btnCom = _btn.getChild('bg', fgui.GComponent);

            _btnCom.getChild('t', fgui.GTextField).text = text;
            _btnCom.getChild('t', fgui.GTextField).fontSize = 40;

            _btn.onClick(() => {
              if (getPlayDisable(_btn)) return;
              this.homeSer.valSer.setMoney(parseInt(text));
            });

            return _btn;
          };

          this.btnv1 = initMoneyBtn('v1', '1');
          this.btnv20 = initMoneyBtn('v20', '20');
          this.btnv50 = initMoneyBtn('v50', '50');
          this.btnv100 = initMoneyBtn('v100', '100');
          this.btnnum0 = bottomView.getChild('num0', fgui.GButton);
          this.btnnum0.onClick(() => {
            if (getPlayDisable(this.btnnum0)) return;
            this.homeSer.valSer.setMoney(0.5, true);
          });
          this.btnnum1 = bottomView.getChild('num1', fgui.GButton);
          const btnnum1Com = this.btnnum1.getChild('bg', fgui.GComponent);
          btnnum1Com.getChild('t', fgui.GTextField).text = '2';
          this.btnnum1.onClick(() => {
            if (getPlayDisable(this.btnnum1)) return;
            this.homeSer.valSer.setMoney(2, true);
          });
          this.startBtn = bottomView.getChild('startBtn', fgui.GButton);
          const startBtnCom = this.startBtn.getChild('bg', fgui.GComponent);
          startBtnCom.getController('theme').selectedIndex = 1;
          const startBtnText = startBtnCom.getChild('t', fgui.GTextField);
          startBtnText.text = 'bet';
          startBtnText.fontSize = 40;
          (_crd && i18n === void 0 ? (_reportPossibleCrUseOfi18n({
            error: Error()
          }), i18n) : i18n).on(startBtnText);
          this.onClick(this.startBtn, async () => {
            this.homeSer.valSer.setCashNum(this.homeSer.valSer.getMoney());
            (_crd && ConfigUtil === void 0 ? (_reportPossibleCrUseOfConfigUtil({
              error: Error()
            }), ConfigUtil) : ConfigUtil).aniTask(async () => {
              const res = await (_crd && ApiHilo === void 0 ? (_reportPossibleCrUseOfApiHilo({
                error: Error()
              }), ApiHilo) : ApiHilo).start({
                optType: 2,
                betGold: this.homeSer.valSer.getMoney()
              });
              this.homeSer.valSer.setBalance(res.data.balance);
              this.showPlayBtn(true);
              bottomView.getController('GameStatus').selectedIndex = 1;
              this.showValBtns(false);
              await this.addHistoryItem(res.data.playerInfo.previousRolls, false);
              this.homeSer.valSer.setPanelVal(res.data);
            });
          });
          this.skipBtn = bottomView.getChild('skipBtn', fgui.GButton);
          const skipBtnCom = this.skipBtn.getChild('bg', fgui.GComponent);
          skipBtnCom.getController('theme').selectedIndex = 3;
          const skipBtnT3 = skipBtnCom.getChild('t3', fgui.GTextField);
          skipBtnT3.text = 'skip';
          (_crd && i18n === void 0 ? (_reportPossibleCrUseOfi18n({
            error: Error()
          }), i18n) : i18n).on(skipBtnT3);
          this.onClick(this.skipBtn, async () => {
            if (getPlayDisable(this.skipBtn)) return;
            (_crd && ConfigUtil === void 0 ? (_reportPossibleCrUseOfConfigUtil({
              error: Error()
            }), ConfigUtil) : ConfigUtil).aniTask(async () => {
              const res = await (_crd && ApiHilo === void 0 ? (_reportPossibleCrUseOfApiHilo({
                error: Error()
              }), ApiHilo) : ApiHilo).skip();
              await this.addHistoryItem(res.data.playerInfo.previousRolls, false);
              this.homeSer.valSer.setPanelVal(res.data);
            });
          });
          this.endBtn = bottomView.getChild('endBtn', fgui.GButton);
          const endBtnCom = this.endBtn.getChild('bg', fgui.GComponent);
          endBtnCom.getController('theme').selectedIndex = 2;
          const endBtnT1 = endBtnCom.getChild('t1', fgui.GTextField);
          endBtnT1.text = 'cashout';
          (_crd && i18n === void 0 ? (_reportPossibleCrUseOfi18n({
            error: Error()
          }), i18n) : i18n).on(endBtnT1);
          this.onClick(this.endBtn, async () => {
            const res = await (_crd && ApiHilo === void 0 ? (_reportPossibleCrUseOfApiHilo({
              error: Error()
            }), ApiHilo) : ApiHilo).cashout();
            this.homeSer.valSer.setBalance(res.data.balance);
            endGame();
          }); //------顶部按钮

          const mainView = this.homeSer.mainView;

          const initTopBtn = (toBtn, text, icon, clickFun, maxLength) => {
            const _BtnText = toBtn.getChild('text', fgui.GTextField);

            _BtnText.text = text;
            (_crd && i18n === void 0 ? (_reportPossibleCrUseOfi18n({
              error: Error()
            }), i18n) : i18n).on(_BtnText, maxLength);

            const _BtnIcon = toBtn.getChild('icon', fgui.GLoader);

            _BtnIcon.url = 'ui://home/' + icon;
            this.onClick(toBtn, clickFun);
          };

          this.lineBtn = mainView.getChild('lineBtn', fgui.GButton);
          initTopBtn(this.lineBtn, 'line', 'btn_netline', () => {});
          this.moreBtn = mainView.getChild('moreBtn', fgui.GButton);
          initTopBtn(this.moreBtn, 'more', 'btn_xiala1', () => {
            mainView.getController('MoreList').selectedIndex = 1;
          });
          const MoreListView = this.homeSer.mainView.getChild('MoreListView', fgui.GComponent);
          this.moreHideBtn = MoreListView.getChild('moreHideBtn', fgui.GButton);
          initTopBtn(this.moreHideBtn, 'less', 'btn_xiala2', () => {
            mainView.getController('MoreList').selectedIndex = 0;
          });
          this.historyBtn = MoreListView.getChild('historyBtn', fgui.GButton);
          initTopBtn(this.historyBtn, 'recoreds', 'btn_history', () => {
            this.homeSer.dialogSer.addHistory();
          }, 3);
          this.ruleBtn = MoreListView.getChild('ruleBtn', fgui.GButton);
          initTopBtn(this.ruleBtn, 'rules', 'btn_help', () => {}, 3);
          this.musicBtn = MoreListView.getChild('musicBtn', fgui.GButton);
          initTopBtn(this.musicBtn, 'music', 'btn_setting', () => {}, 3);
          this.langBtn = MoreListView.getChild('langBtn', fgui.GButton);
          initTopBtn(this.langBtn, 'lang', 'btn_lang', () => {
            (_crd && i18n === void 0 ? (_reportPossibleCrUseOfi18n({
              error: Error()
            }), i18n) : i18n).setLang((_crd && i18n === void 0 ? (_reportPossibleCrUseOfi18n({
              error: Error()
            }), i18n) : i18n).lang === 'zh' ? 'en' : 'zh');
          }, 3);
        }

        onDestroy() {}

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=adc364074813c217941751d1c7117fbe4112c97e.js.map