System.register(["cc"], function (_export, _context) {
  "use strict";

  var __checkObsolete__, __checkObsoleteInNamespace__, _cc, KeyCode, input, Input, AudioClip, Node, AudioSource, director, CKeyUtil, Cocos3x, Res, SoundBean, Sound, Ci18n, cc, Key_EventType, __awaiter$3, __awaiter$2, __awaiter$1, __awaiter;

  return {
    setters: [function (_cc2) {
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
      KeyCode = _cc2.KeyCode;
      input = _cc2.input;
      Input = _cc2.Input;
      AudioClip = _cc2.AudioClip;
      Node = _cc2.Node;
      AudioSource = _cc2.AudioSource;
      director = _cc2.director;
    }],
    execute: function () {
      cc = __checkObsoleteInNamespace__(_cc);

      __checkObsolete__(['KeyCode', 'input', 'Input', 'AudioClip', 'Node', 'AudioSource', 'director']);

      !function (t) {
        t.KEY_DOWN = "KEY_DOWN", t.KEY_UP = "KEY_UP";
      }(Key_EventType || (Key_EventType = {}));

      _export("CKeyUtil", CKeyUtil = class CKeyUtil {
        static init() {
          var t = CKeyUtil;

          for (var e in KeyCode) {
            var n = KeyCode[e];
            "string" != typeof n && (t.keyMap[n] = {
              keyName: e,
              keyCode: n
            });
          }

          input.on(Input.EventType.KEY_DOWN, e => {
            var n = t.keyMap[e.keyCode].keyName;
            CEvent.emit(Key_EventType.KEY_DOWN, {
              key: n
            });
          }), input.on(Input.EventType.KEY_UP, e => {
            var n = t.keyMap[e.keyCode].keyName;
            CEvent.emit(Key_EventType.KEY_UP, {
              key: n
            });
          });
        }

        static on(t, e) {
          var n = {};
          var i = CEvent.on(Key_EventType.KEY_DOWN, i => {
            !function (i) {
              var o = i.key;
              if (n[o]) return;
              n[o] = !0;
              var a = t[t.length - 1] === o;
              var s = !0;

              for (var _e = 0; _e < t.length - 1; _e++) if (!n[t[_e]]) {
                s = !1;
                break;
              }

              a && s && e();
            }(i);
          }),
              o = CEvent.on(Key_EventType.KEY_UP, t => {
            !function (t) {
              var e = t.key;
              n[e] = !1;
            }(t);
          });
          return () => {
            CEvent.off(i, o);
          };
        }

      });

      CKeyUtil.keyMap = {}, CKeyUtil.eventMap = {};
      Cocos3x = class Cocos3x {};
      Cocos3x.Ci18n = {};

      __awaiter$3 = function __awaiter$3(t, e, n, i) {
        return new (n || (n = Promise))(function (o, a) {
          function s(t) {
            try {
              r(i.next(t));
            } catch (t) {
              a(t);
            }
          }

          function u(t) {
            try {
              r(i.throw(t));
            } catch (t) {
              a(t);
            }
          }

          function r(t) {
            var e;
            t.done ? o(t.value) : (e = t.value, e instanceof n ? e : new n(function (t) {
              t(e);
            })).then(s, u);
          }

          r((i = i.apply(t, e || [])).next());
        });
      };

      _export("Res", Res = class Res {
        static getAsset(t, e, n) {
          if (e === void 0) {
            e = null;
          }

          if (n === void 0) {
            n = Res.bundleName;
          }

          return new Promise((i, o) => {
            Res.bundleMap[n].load(t, e, (t, e) => {
              i(e);
            });
          });
        }

        static loadBundle(t, e) {
          return new Promise((n, i) => {
            var o = Date.now();
            cc.assetManager.loadBundle(t, function (i, a) {
              Res.bundleMap[t] = a;
              var s = a.getDirWithPath("");

              if ((null == e ? void 0 : e.pathList) && (s = s.filter(t => e.pathList.find(e => e.startsWith(t.path)))), Res.i18n) {
                var _t = (null == e ? void 0 : e.lang) || Cocos3x.Ci18n.lang;

                var _n = s.map(t => {
                  var e = Cocos3x.Ci18n.pathInList(t.path);
                  return e.status ? t.path.split(Cocos3x.Ci18n.langList[e.index])[0] : null;
                }).filter(t => t);

                _n = _n.filter((t, e, n) => n.indexOf(t) === e), s = s.filter(e => {
                  for (var _i = 0; _i < _n.length; _i++) if (e.path.startsWith(_n[_i])) {
                    if (Cocos3x.Ci18n.defaultLang === _t) {
                      return !Cocos3x.Ci18n.pathInList(e.path).status;
                    }

                    return -1 !== e.path.indexOf("_" + _t);
                  }

                  return !0;
                });
              }

              (null == e ? void 0 : e.dirCallback) && (s = e.dirCallback(s));
              var u = [],
                  r = [];

              for (var _t2 = 0; _t2 < s.length; _t2++) {
                var _e2 = s[_t2];
                _e2.ctor == cc.Prefab ? u.push(_e2) : r.push(_e2);
              }

              var c = s.length;
              var l = 0;

              var d = (i, u) => {
                l++;
                var r = l / c * 100,
                    d = Date.now() - o,
                    p = {
                  bundle: a,
                  dir: s,
                  info: i,
                  totalTime: d,
                  bundleName: t,
                  progress: r
                };
                (null == e ? void 0 : e.onProgress) && e.onProgress(p), u && u(l, r), 100 === r && (Cocos3x.Ci18n.loadResMap(t), n(!0));
              },
                  p = () => {
                if (u.length) {
                  Cocos3x.Ci18n.loadResMap(t);

                  var _loop = function _loop() {
                    var e = u[_t3];
                    a.load(e.path, (t, n) => {
                      d(e);
                    });
                  };

                  for (var _t3 = 0; _t3 < u.length; _t3++) {
                    _loop();
                  }
                }
              };

              var _loop2 = function _loop2() {
                var e = r[_t4];
                a.load(e.path, (t, n) => {
                  d(e, (t, e) => {
                    t === r.length && p();
                  });
                });
              };

              for (var _t4 = 0; _t4 < r.length; _t4++) {
                _loop2();
              }
            });
          });
        }

        static loadBundles(t, e) {
          return new Promise((n, i) => __awaiter$3(this, void 0, void 0, function* () {
            for (var _n2 = 0; _n2 < t.length; _n2++) {
              var _i2 = t[_n2];
              yield Res.loadBundle(_i2, e);
            }

            n(!0);
          }));
        }

      });

      Res.bundleMap = {}, Res.bundleName = "home", Res.i18n = !0;

      __awaiter$2 = function __awaiter$2(t, e, n, i) {
        return new (n || (n = Promise))(function (o, a) {
          function s(t) {
            try {
              r(i.next(t));
            } catch (t) {
              a(t);
            }
          }

          function u(t) {
            try {
              r(i.throw(t));
            } catch (t) {
              a(t);
            }
          }

          function r(t) {
            var e;
            t.done ? o(t.value) : (e = t.value, e instanceof n ? e : new n(function (t) {
              t(e);
            })).then(s, u);
          }

          r((i = i.apply(t, e || [])).next());
        });
      };

      SoundBean = class SoundBean {
        constructor() {
          this.node = null, this.audioSource = null, this.id = null, this.param = null;
        }

        setConfig(t) {
          return __awaiter$2(this, void 0, void 0, function* () {
            this.param = t;
            var {
              bundleName: e,
              musicName: n,
              volume: i
            } = this.param;
            this.id = StrUtil.getId();
            var o = t.dir + n;
            var a = yield t.Res.getAsset(o, AudioClip, e);
            this.node = new Node(), this.audioSource = this.node.addComponent(AudioSource), this.audioSource.playOnAwake = t.autoPlay, this.setClip(a), this.setVolume(i), this.audioSource.node.on(AudioSource.EventType.STARTED, this.onAudioStarted, this), this.audioSource.node.on(AudioSource.EventType.ENDED, this.onAudioEnded, this);
          });
        }

        onAudioStarted() {
          this.param.startFun && this.param.startFun();
        }

        onAudioEnded() {
          this.param.endFun && this.param.endFun(), this.param.loop && this.play();
        }

        play() {
          this.audioSource.play();
        }

        stop() {
          this.audioSource.stop();
        }

        pause() {
          this.audioSource.pause();
        }

        resume() {
          this.play();
        }

        setClip(t) {
          this.audioSource.clip = t;
        }

        setVolume(t) {
          this.audioSource.volume = t;
        }

        destroy() {
          this.setVolume(0), this.audioSource.node.off(AudioSource.EventType.STARTED, this.onAudioStarted, this), this.audioSource.node.off(AudioSource.EventType.ENDED, this.onAudioEnded, this), this.node.removeFromParent(), this.node.destroy();
        }

      };

      __awaiter$1 = function __awaiter$1(t, e, n, i) {
        return new (n || (n = Promise))(function (o, a) {
          function s(t) {
            try {
              r(i.next(t));
            } catch (t) {
              a(t);
            }
          }

          function u(t) {
            try {
              r(i.throw(t));
            } catch (t) {
              a(t);
            }
          }

          function r(t) {
            var e;
            t.done ? o(t.value) : (e = t.value, e instanceof n ? e : new n(function (t) {
              t(e);
            })).then(s, u);
          }

          r((i = i.apply(t, e || [])).next());
        });
      };

      _export("Sound", Sound = class Sound {
        static init(t) {
          var e = Sound;
          e.Res = t || Res, e.boundMap = {}, e.rootNode = new Node(), e.rootNode.name = "__Sound__" + StrUtil.getId(), director.getScene().addChild(e.rootNode), director.addPersistRootNode(e.rootNode);
        }

        static play(t, e) {
          if (e === void 0) {
            e = {};
          }

          return __awaiter$1(this, void 0, void 0, function* () {
            var n = Sound;
            void 0 === e.autoPlay && (e.autoPlay = !0);
            var i = new SoundBean();
            return e = n.getParam(t, e), yield i.setConfig(e), i.setVolume(i.param.volume * n.volume), n.rootNode.addChild(i.node), e.autoPlay && i.play(), n.boundMap[e.musicName + "-" + e.bundleName] = i, i;
          });
        }

        static getParam(t, e) {
          var n = Sound;
          return e.dir = n.dir, e.Res = n.Res, Object.assign({
            musicName: t,
            bundleName: e.bundleName || e.Res.bundleName,
            loop: !1,
            volume: Sound.volume
          }, e);
        }

        static getSoundBean(t, e) {
          if (e === void 0) {
            e = {};
          }

          var n = Sound;
          return e = n.getParam(t, e), n.boundMap[e.musicName + "-" + e.bundleName];
        }

        static stop(t, e) {
          if (e === void 0) {
            e = {};
          }

          var n;
          null === (n = Sound.getSoundBean(t, e)) || void 0 === n || n.stop();
        }

        static pause(t, e) {
          if (e === void 0) {
            e = {};
          }

          var n;
          null === (n = Sound.getSoundBean(t, e)) || void 0 === n || n.pause();
        }

        static resume(t, e) {
          if (e === void 0) {
            e = {};
          }

          var n;
          null === (n = Sound.getSoundBean(t, e)) || void 0 === n || n.resume();
        }

        static destroy(t, e) {
          if (e === void 0) {
            e = {};
          }

          var n = Sound,
              i = (e = n.getParam(t, e)).musicName + "-" + e.bundleName;
          n.boundMap[i].destroy(), n.boundMap[i] = void 0, delete n.boundMap[i];
        }

        static setVolume(t) {
          var e = Sound;
          e.volume = t, Object.keys(e.boundMap).forEach(n => {
            var i = e.boundMap[n];
            i.setVolume(i.param.volume * t);
          });
        }

      });

      Sound.boundMap = null, Sound.rootNode = null, Sound.volume = 1, Sound.dir = "sound/", Sound.Res = null;

      __awaiter = function __awaiter(t, e, n, i) {
        return new (n || (n = Promise))(function (o, a) {
          function s(t) {
            try {
              r(i.next(t));
            } catch (t) {
              a(t);
            }
          }

          function u(t) {
            try {
              r(i.throw(t));
            } catch (t) {
              a(t);
            }
          }

          function r(t) {
            var e;
            t.done ? o(t.value) : (e = t.value, e instanceof n ? e : new n(function (t) {
              t(e);
            })).then(s, u);
          }

          r((i = i.apply(t, e || [])).next());
        });
      };

      _export("I18n", Ci18n = class Ci18n {
        static init(t) {
          Object.defineProperty(cc.Node.prototype, "addChild", {
            value: function value(t) {
              Ci18n.setNodeLang(t), t.setParent(this);
            }
          });
          var e = cc.assetManager.packManager.load;
          cc.assetManager.packManager.load = function (t, n, i) {
            var o = i;
            return i = (e, n) => {
              var i;

              if (Ci18n.lang !== Ci18n.defaultLang) {
                if ((null === (i = t.info) || void 0 === i ? void 0 : i.ctor) == cc.Prefab) {
                  var _t5 = (t, e) => Object.keys(Ci18n.resMap).find(n => Ci18n.resMap[n].path == t && Ci18n.resMap[n].ctor == e),
                      _e3 = {
                    Sprite: e => {
                      var n = e._spriteFrame.__uuid__ || e._spriteFrame.uuid;

                      if (n) {
                        var _i3 = Ci18n.resMap[n];

                        if (_i3) {
                          if (_i3.path.endsWith("/spriteFrame")) {
                            var _e4 = _i3.path.split("/spriteFrame");

                            n = _t5(_e4[0] + "_" + Ci18n.lang + "/spriteFrame", cc.SpriteFrame);
                          } else {
                            var _e5 = _i3.path.substring(0, _i3.path.lastIndexOf("/")),
                                _o = _i3.path.substring(_i3.path.lastIndexOf("/"));

                            n = _t5(_e5 + "_" + Ci18n.lang + _o, cc.SpriteFrame);
                          }

                          e._spriteFrame.uuid = n, e._spriteFrame.__uuid__ = n;
                        }
                      }

                      return e;
                    },
                    Skeleton: e => {
                      var n = e._skeletonData.__uuid__ || e._skeletonData.uuid;

                      if (n) {
                        var _i4 = Ci18n.resMap[n];
                        _i4 && (n = _t5(_i4.path + "_" + Ci18n.lang, cc.sp.SkeletonData), e._skeletonData.__uuid__ = n, e._skeletonData.uuid = n);
                      }

                      return e;
                    }
                  };

                  if (Array.isArray(n)) for (var _t6 = 0; _t6 < n.length; _t6++) {
                    var _i5 = n[_t6];
                    _i5._spriteFrame ? _e3.Sprite(_i5) : _i5._skeletonData && _e3.Skeleton(_i5);
                  }
                }
              }

              o(e, n);
            }, e.call(cc.assetManager.packManager, t, n, i);
          }, Ci18n.lang = t.lang, Ci18n.defaultLang = t.defaultLang, Ci18n.langList = t.langList.map(t => "_" + t);
        }

        static on(t) {
          var e = StrUtil.uuid();
          return Ci18n.map[e] = t, Ci18n.setNodeLang(t), e;
        }

        static off(t) {
          delete Ci18n.map[t];
        }

        static clear() {
          Ci18n.map = {};
        }

        static getLangJson(t) {
          return __awaiter(this, void 0, void 0, function* () {
            try {
              if (Ci18n.langJson[t]) return Ci18n.langJson[t];
              var e = yield http.get({
                url: "/lang/" + t + ".json",
                timeout: 5e3
              });
              return "string" == typeof e && (e = JSON.parse(e)), Ci18n.langJson[t] = e, e;
            } catch (t) {
              return;
            }
          });
        }

        static setNodeLang(t) {
          return __awaiter(this, void 0, void 0, function* () {
            var e = t => __awaiter(this, void 0, void 0, function* () {
              var n, i, o;
              var a = t.getComponent(cc.Label),
                  s = t.getComponent(cc.Sprite),
                  u = t.getComponent(cc.AudioSource),
                  r = t.getComponent(cc.sp.Skeleton);

              try {
                if (a) {
                  Ci18n.sourceMap[t.uuid] || (Ci18n.sourceMap[t.uuid] = {
                    text: a.string
                  });
                  var _e6 = Ci18n.sourceMap[t.uuid].text;

                  var _n3 = yield Ci18n.getLangJson(Ci18n.lang);

                  if (_n3) {
                    var _t7 = ObjectUtil.getPathValue(_n3, _e6);

                    _t7 !== a.string && (a.string = _t7);
                  }
                }

                if (s) {
                  var _e7 = null === (n = s.spriteFrame) || void 0 === n ? void 0 : n.uuid,
                      _i6 = Ci18n.resMap[_e7];

                  if (_i6) {
                    var _e8 = _i6.path.split("/spriteFrame")[0];

                    if (!Ci18n.sourceMap[t.uuid]) {
                      var _n4 = Cocos3x.Ci18n.pathInList(_e8);

                      _n4.status && (_e8 = _e8.replace(Cocos3x.Ci18n.langList[_n4.index], "")), Ci18n.sourceMap[t.uuid] = {
                        text: _e8
                      };
                    }

                    var _n5 = Ci18n.sourceMap[t.uuid].text,
                        _o2 = _n5.split("/spriteFrame")[0];

                    var _a = _o2.substring(0, _o2.lastIndexOf("/")),
                        _u = _o2.substring(_o2.lastIndexOf("/"));

                    Ci18n.lang !== Ci18n.defaultLang && (_o2 = _a + "_" + Ci18n.lang + _u);

                    var _r = yield Res.getAsset(_o2, cc.SpriteFrame, _i6.bundleName);

                    if (_r instanceof cc.SpriteFrame) s.spriteFrame = _r;else {
                      var _t8 = _n5.split("/spriteFrame")[0];

                      Ci18n.lang !== Ci18n.defaultLang && (_t8 += "_" + Ci18n.lang), _t8 += "/spriteFrame";

                      var _e9 = yield Res.getAsset(_t8, cc.SpriteFrame, _i6.bundleName);

                      _e9 instanceof cc.SpriteFrame && (s.spriteFrame = _e9);
                    }
                  }
                }

                if (u) {
                  var _e10 = null === (i = u.clip) || void 0 === i ? void 0 : i.uuid,
                      _n6 = Ci18n.resMap[_e10];

                  if (_n6) {
                    var _e11 = _n6.path;

                    if (!Ci18n.sourceMap[t.uuid]) {
                      var _n7 = Cocos3x.Ci18n.pathInList(_e11);

                      _n7.status && (_e11 = _e11.replace(Cocos3x.Ci18n.langList[_n7.index], "")), Ci18n.sourceMap[t.uuid] = {
                        text: _e11
                      };
                    }

                    var _i7 = Ci18n.sourceMap[t.uuid].text;
                    Ci18n.lang !== Ci18n.defaultLang && (_i7 += "_" + Ci18n.lang);

                    var _o3 = yield Res.getAsset(_i7, cc.AudioClip, _n6.bundleName);

                    _o3 && (u.clip = _o3);
                  }
                }

                if (r) {
                  var _e12 = null === (o = r.skeletonData) || void 0 === o ? void 0 : o.uuid,
                      _n8 = Ci18n.resMap[_e12];

                  if (_n8) {
                    var _e13 = _n8.path;

                    if (!Ci18n.sourceMap[t.uuid]) {
                      var _n9 = Cocos3x.Ci18n.pathInList(_e13);

                      _n9.status && (_e13 = _e13.replace(Cocos3x.Ci18n.langList[_n9.index], "")), Ci18n.sourceMap[t.uuid] = {
                        text: _e13
                      };
                    }

                    var _i8 = Ci18n.sourceMap[t.uuid].text;
                    Ci18n.lang !== Ci18n.defaultLang && (_i8 += "_" + Ci18n.lang);

                    var _o4 = yield Res.getAsset(_i8, cc.sp.SkeletonData, _n8.bundleName);

                    if (_o4) {
                      var _t9 = r.animation,
                          _e14 = r.loop;
                      r.skeletonData = _o4, r.setAnimation(0, _t9, _e14);
                    }
                  }
                }
              } catch (t) {
                console.log("error", t);
              }

              for (var _n10 = 0; _n10 < t.children.length; _n10++) {
                var _i9 = t.children[_n10];
                e(_i9);
              }
            });

            e(t);
          });
        }

        static loadResMap(t) {
          var e, n;
          var i = null === (n = null === (e = Res.bundleMap[t]._config) || void 0 === e ? void 0 : e.assetInfos) || void 0 === n ? void 0 : n._map;
          i && Object.keys(i).forEach(e => {
            Ci18n.resMap[e] = Object.assign(Object.assign({}, i[e]), {
              bundleName: t
            });
          });
        }

        static setLang(t) {
          return __awaiter(this, void 0, void 0, function* () {
            if (Ci18n.lang === t) return;
            Ci18n.lang = t;
            var e = Object.keys(Ci18n.map);

            for (var _t10 = 0; _t10 < e.length; _t10++) {
              var n = e[_t10];
              Ci18n.setNodeLang(Ci18n.map[n]);
            }
          });
        }

        static pathInList(t) {
          var e = Cocos3x.Ci18n.langList;

          for (var n = 0; n < e.length; n++) if (-1 !== t.indexOf(e[n])) return {
            status: !0,
            index: n
          };

          return {
            status: !1,
            index: -1
          };
        }

      });

      Ci18n.langJson = {}, Ci18n.map = {}, Ci18n.sourceMap = {}, Ci18n.defaultLang = "en", Ci18n.lang = "en", Ci18n.langList = [], Ci18n.resMap = {}, Cocos3x.Ci18n = Ci18n;
    }
  };
});
//# sourceMappingURL=5320406d8f1dd42a6588a8a9e30a3ffb256141ed.js.map