System.register(["__unresolved_0", "cc", "tools-cocos38"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, fgui, _cc, aniSer, _crd, cc;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  function _reportPossibleCrUseOfhomeSer(extras) {
    _reporterNs.report("homeSer", "../homeSer", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }, function (_toolsCocos) {
      fgui = _toolsCocos;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "331bdefSNtGJrUi0qPi1Dt1", "aniSer", undefined);

      cc = __checkObsoleteInNamespace__(_cc);

      _export("default", aniSer = class aniSer {
        constructor(homeSer) {
          var _this = this;

          /**
           * 显示隐藏跳过按钮和兑奖按钮
           */
          this.showSkipBtn = show => {
            this.homeSer.btnSer.bottomView.getController('GameStatus').selectedIndex = show ? 1 : 0;
          };

          /**
           * 显示新牌动画
           * @param item
           * @returns
           */
          this.cardShow = /*#__PURE__*/_asyncToGenerator(function* (item) {
            return new Promise(res => {
              _this.homeSer.cardSer.cardItem.setCard(item.num, item.color);

              var csAni = _this.homeSer.mainView.getTransition('cardShow');

              csAni.setHook('end', () => {
                csAni.clearHooks();
                res(true);
              });
              csAni.play();
            });
          });

          /**
           * 显示结束动画
           */
          this.cardFail = /*#__PURE__*/_asyncToGenerator(function* () {
            return new Promise(res => {
              _this.homeSer.cardView.getController('failStatus').selectedIndex = 1;

              var csAni = _this.homeSer.mainView.getTransition('cardFail');

              csAni.setHook('end', () => {
                csAni.clearHooks();
                _this.homeSer.cardView.getController('failStatus').selectedIndex = 0;
                res(true);
              });
              csAni.play();
            });
          });

          /**
           * 将牌移动到历史列表中
           * @param toNode
           */
          this.moveTop = /*#__PURE__*/_asyncToGenerator(function* () {
            return new Promise(res => {
              var toIndex = _this.homeSer.historySer.list.numItems - 1;
              if (toIndex > 7) toIndex = 7;
              var toNode = _this.homeSer.historySer.hArr[toIndex];
              var cardView = _this.homeSer.cardView;
              var mainView = _this.homeSer.mainView;
              var bgBox = mainView.getChild('bg', fgui.GGraph);
              var toPos = toNode.localToGlobal(bgBox.x, bgBox.y);
              var {
                x,
                y
              } = cardView.node.position;
              cc.tween(cardView.node).to(0.6, {
                scale: new cc.Vec3(toNode.width / cardView.width, toNode.height / cardView.height, 1),
                position: new cc.Vec3(toPos.x + toNode.width / 2,
                /**
                 * 110：初始y坐标
                 * 210：初始y全局坐标 使用this.homeSer.historyView.localToGlobal(0, 0)获取
                 */
                -(_this.homeSer.historyView.y - 110 + 210) + toNode.height / 2 + 5, 1)
              }, {
                easing: 'linear'
              }).call(() => {
                cardView.alpha = 0;
                cardView.node.setPosition(x, y, 1);
                cardView.node.setScale(1, 1, 1);
                res(true);
              }).start();
              mainView.getTransition('cardRotate').play();
            });
          });
          this.homeSer = homeSer;
        }

        onDestroy() {}

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=84439bc9181a7867b904ffc8bfea35c8750fe3d3.js.map