System.register(["__unresolved_0", "cc", "__unresolved_1", "__unresolved_2"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, Node, director, RouterTag, SoundBean, SoundUtil, _crd;

  function _reportPossibleCrUseOfRouterTag(extras) {
    _reporterNs.report("RouterTag", "../enum/Enum", _context.meta, extras);
  }

  function _reportPossibleCrUseOfSoundBean(extras) {
    _reporterNs.report("SoundBean", "./SoundBean", _context.meta, extras);
  }

  function _reportPossibleCrUseOfSoundBeanParam(extras) {
    _reporterNs.report("SoundBeanParam", "./SoundBean", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      __checkObsolete__ = _cc.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc.__checkObsoleteInNamespace__;
      Node = _cc.Node;
      director = _cc.director;
    }, function (_unresolved_2) {
      RouterTag = _unresolved_2.RouterTag;
    }, function (_unresolved_3) {
      SoundBean = _unresolved_3.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "68717npvhhMcZTBCTHm69Kv", "SoundUtil", undefined);

      __checkObsolete__(['Node', 'director']);

      /**
       * 播放音频类
       */
      _export("default", SoundUtil = class SoundUtil {
        static init() {
          var that = SoundUtil;
          that.boundMap = {};
          that.rootNode = new Node();
          that.rootNode.name = '__SoundUtil__' + StrUtil.getId();
          director.getScene().addChild(that.rootNode);
          director.addPersistRootNode(that.rootNode);
        }

        static play(musicName, param) {
          if (param === void 0) {
            param = {};
          }

          var that = SoundUtil;

          var _SoundBean = new (_crd && SoundBean === void 0 ? (_reportPossibleCrUseOfSoundBean({
            error: Error()
          }), SoundBean) : SoundBean)();

          param = that.getParam(musicName, param);

          _SoundBean.setConfig(param);

          that.rootNode.addChild(_SoundBean.node);

          _SoundBean.play();

          that.boundMap[param.musicName + '-' + param.bundleName] = _SoundBean;
        }

        static getParam(musicName, param) {
          return Object.assign({
            musicName,
            bundleName: (_crd && RouterTag === void 0 ? (_reportPossibleCrUseOfRouterTag({
              error: Error()
            }), RouterTag) : RouterTag).common,
            loop: false,
            volume: SoundUtil.volume,
            endedFun: () => {}
          }, param);
        }

        static getSoundBean(musicName, param) {
          if (param === void 0) {
            param = {};
          }

          var that = SoundUtil;
          param = that.getParam(musicName, param);
          return that.boundMap[param.musicName + '-' + param.bundleName];
        }

        static stop(musicName, param) {
          var _SoundUtil$getSoundBe;

          if (param === void 0) {
            param = {};
          }

          (_SoundUtil$getSoundBe = SoundUtil.getSoundBean(musicName, param)) == null || _SoundUtil$getSoundBe.stop();
        }

        static pause(musicName, param) {
          var _SoundUtil$getSoundBe2;

          if (param === void 0) {
            param = {};
          }

          (_SoundUtil$getSoundBe2 = SoundUtil.getSoundBean(musicName, param)) == null || _SoundUtil$getSoundBe2.pause();
        }

        static resume(musicName, param) {
          var _SoundUtil$getSoundBe3;

          if (param === void 0) {
            param = {};
          }

          (_SoundUtil$getSoundBe3 = SoundUtil.getSoundBean(musicName, param)) == null || _SoundUtil$getSoundBe3.resume();
        }
        /**
         * 销毁音乐资源对象
         * @param musicName 
         * @param param 
         */


        static destroy(musicName, param) {
          if (param === void 0) {
            param = {};
          }

          var that = SoundUtil;
          param = that.getParam(musicName, param);

          var _key = param.musicName + '-' + param.bundleName;

          var _SoundBean = that.boundMap[_key];

          _SoundBean.destroy();

          that.boundMap[_key] = undefined;
          delete that.boundMap[_key];
        }
        /**
         * 整体调整所有音量大小
         * @param volume
         */


        static setVolume(volume) {
          var that = SoundUtil;
          Object.keys(that.boundMap).forEach(key => {
            var _SoundBean = that.boundMap[key];

            _SoundBean.setVolume(_SoundBean.param.volume * volume);
          });
        }

      });

      /**
       * Store playlist
       */
      SoundUtil.boundMap = null;

      /**
       * 音频全局挂载接点
       */
      SoundUtil.rootNode = null;

      /**
       * 全局默认音量大小
       */
      SoundUtil.volume = 1;

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=da77617fb8c835ae6a03b42a98af5dffe6b25357.js.map