const path = require("path")

const onBeforeBuild = async function (options, result,{ file,http }) {
}

const onAfterBuild = async function (options, result,{ file }) {

    //处理自适应
    await file.readDirectory(path.join(result.dest, 'cocos-js'),async (filepath)=>{
        const filename = filepath.substring(filepath.lastIndexOf('\\')+1)
        if(filename.startsWith('_virtual_cc')){
            let _content = await file.readFile(filepath)
            _content = _content.replace(/window\.innerHeight/g,'H5Util.getMaxHeight()').replace(/window\.innerWidth/g,'H5Util.getMaxWidth()')
            await file.writeFile(filepath, _content)
        }
    })
}

module.exports = {
    onBeforeBuild,
    onAfterBuild
}