const _style = document.createElement('style');

// 设置style标签的内容
_style.innerHTML = `
#error {
    top:99999 !important;
}

#__vconsole {
    display: none !important;
}

#BGImg {
    position: absolute;
    width: 100%;
    height: 100%;
    background-size: cover;
    top: 0;
    bottom: -10%;
    left: 0;
    right: 0;
    background-image: url(./cocosjs/img/bg.jpg);
    background-position: center center;
    visibility: visible;
}

@keyframes rotateRund {
    from {
        transform: rotate(360deg);
    }

    to {
        transform: rotate(0deg);
    }
}

@keyframes rotateEyeLeft {
    from {
        transform: translateX(-24px) rotate(360deg);
    }

    to {
        transform: translateX(-24px) rotate(0deg);
    }
}

@keyframes rotateEyeRight {
    from {
        transform: translateX(24px) rotate(360deg);
    }

    to {
        transform: translateX(24px) rotate(0deg);
    }
}

#loadAni {
    position: fixed;
    display: flex;
    width: 100vw;
    height: 100vh;
    justify-content: center;
    align-items: center;
}

#loadAni img {
    position: absolute;
}
`;

document.head.appendChild(_style);
const loadAniDiv = document.createElement('div');
loadAniDiv.id = 'loadAni';
loadAniDiv.zIndex = 9999;

const roundImg = document.createElement('img');
roundImg.src = './cocosjs/img/round.png';
roundImg.style.animation = 'rotateRund 2s linear infinite';

const headImg = document.createElement('img');
headImg.src = './cocosjs/img/head.png';

const leftEyeImg = document.createElement('img');
leftEyeImg.src = './cocosjs/img/eye.png';
leftEyeImg.style.animation = 'rotateEyeLeft 2s linear infinite';

const rightEyeImg = document.createElement('img');
rightEyeImg.src = './cocosjs/img/eye.png';
rightEyeImg.style.animation = 'rotateEyeRight 2s linear infinite';

// 加载动画
loadAniDiv.appendChild(roundImg);
loadAniDiv.appendChild(headImg);
loadAniDiv.appendChild(leftEyeImg);
loadAniDiv.appendChild(rightEyeImg);

document.body.appendChild(loadAniDiv);
        
// 背景
const _div = document.createElement('div')
_div.id = 'BGImg'
_div.style.opacity = 0
document.body.insertBefore(_div, document.body.firstChild)

CEvent.on('toggleGameDiv', (data) => {
    if (data){
        document.body.removeChild(loadAniDiv)
        _div.style.opacity = 1
    }
})