System.register(["cc"], function (_export, _context) {
  "use strict";

  var __checkObsolete__, __checkObsoleteInNamespace__, _cc, I18n, _crd, cc, langArr;

  _export("I18n", void 0);

  return {
    setters: [function (_cc2) {
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }],
    execute: function () {
      _crd = true;
      cc = __checkObsoleteInNamespace__(_cc);
      langArr = ['text', 'image', 'music'];

      _export("I18n", I18n = class I18n {
        static on(node) {
          const id = StrUtil.uuid();
          console.log(node);
          I18n.map[id] = node;
          return id;
        }

        static setNodeLang(node) {
          node.children.forEach(child => {
            const text = child.getComponent(cc.Label);

            if (text) {
              console.log(text);
              text.string = '123';
            }

            I18n.setNodeLang(child);
          });
        }

        static off(id) {
          delete I18n.map[id];
        }

        static setLang(lang) {
          Object.keys(I18n.map).forEach(key => {
            I18n.setNodeLang(I18n.map[key]);
          });
        }

      });

      I18n.map = {};
      I18n.lang = 'en';
      _crd = false;
    }
  };
});
//# sourceMappingURL=45fa71a2dc2b99f288409d76daa58d64661dfe37.js.map