System.register(["cc", "tools-cocos38"], function (_export, _context) {
  "use strict";

  var _cclegacy, fgui, FguiUtil, _crd;

  _export("default", void 0);

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }, function (_toolsCocos) {
      fgui = _toolsCocos;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "f008ahhJWZPBLLsP8QFdRn0", "FguiUtil", undefined);

      _export("default", FguiUtil = class FguiUtil {
        /**
         * init fgui
         * @param packageName
         * @param comName
         * @returns
         */
        static initView(packageName, comName) {
          let thisView = fgui.UIPackage.createObject(packageName, comName).asCom;
          fgui.GRoot.inst.addChild(thisView);
          thisView.makeFullScreen();
          thisView.addRelation(fgui.GRoot.inst, fgui.RelationType.Size, true);
          return thisView;
        }
        /**
         * Add components to the current fgui node
         * @param packageName
         * @param comName
         * @param show
         * @returns
         */


        static addCom(packageName, comName, show = false) {
          let thisView = fgui.UIPackage.createObject(packageName, comName).asCom;
          thisView.visible = show;
          fgui.GRoot.inst.addChild(thisView);
          thisView.makeFullScreen();
          return thisView;
        }

      });

      FguiUtil.addPackage = () => {};

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=5b735890ea229987fbddbe8c7b1a49b464f74dd6.js.map