System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _cc, _class, _crd, cc, ccclass, touchSingle;

  return {
    setters: [function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "c8073Ji0ilG0pUD40G+agvJ", "touchSingle", undefined);

      cc = __checkObsoleteInNamespace__(_cc);
      ({
        ccclass
      } = cc._decorator);
      /**
       * Limit to a single touch click, which node to use directly add components can be
       * @example
       * this.node.addComponent(touchSingle)
       */

      _export("default", touchSingle = ccclass(_class = class touchSingle extends cc.Component {
        constructor(...args) {
          super(...args);
          this._touchID = null;
        }

        _touchStart(event) {
          if (this._touchID !== null) {
            event.stopPropagation();
          } else {
            this._touchID = event.getID();
          }
        }

        _touchMove(event) {
          if (this._touchID !== event.getID()) {
            event.stopPropagation();
          }
        }

        _touchEnd(event) {
          if (this._touchID !== event.getID()) {
            event.stopPropagation();
          } else if (!event.simulate) {
            this._touchID = null;
          }
        }

        onEnable() {
          this.node.on(cc.Node.EventType.TOUCH_START, this._touchStart, this, true);
          this.node.on(cc.Node.EventType.TOUCH_MOVE, this._touchMove, this, true);
          this.node.on(cc.Node.EventType.TOUCH_END, this._touchEnd, this, true);
          this.node.on(cc.Node.EventType.TOUCH_CANCEL, this._touchEnd, this, true);
        }

        onDisable() {
          this.node.off(cc.Node.EventType.TOUCH_START, this._touchStart, this, true);
          this.node.off(cc.Node.EventType.TOUCH_MOVE, this._touchMove, this, true);
          this.node.off(cc.Node.EventType.TOUCH_END, this._touchEnd, this, true);
          this.node.off(cc.Node.EventType.TOUCH_CANCEL, this._touchEnd, this, true);
        }

      }) || _class);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=722adb59d45f2e21b5e1f1af6e6ea514b8513ad3.js.map