System.register(["__unresolved_0", "cc", "tools-cocos38"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, fgui, _cc, aniSer, _crd, cc;

  function _reportPossibleCrUseOfhomeSer(extras) {
    _reporterNs.report("homeSer", "../homeSer", _context.meta, extras);
  }

  _export("default", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }, function (_toolsCocos) {
      fgui = _toolsCocos;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "331bdefSNtGJrUi0qPi1Dt1", "aniSer", undefined);

      cc = __checkObsoleteInNamespace__(_cc);

      _export("default", aniSer = class aniSer {
        constructor(homeSer) {
          /**
           * 显示隐藏跳过按钮和兑奖按钮
           */
          this.showSkipBtn = show => {
            this.homeSer.btnSer.bottomView.getController('GameStatus').selectedIndex = show ? 1 : 0;
          };

          /**
           * 显示新牌动画
           * @param item
           * @returns
           */
          this.cardShow = async item => {
            return new Promise(res => {
              this.homeSer.cardSer.cardItem.setCard(item.num, item.color);
              const csAni = this.homeSer.mainView.getTransition('cardShow');
              csAni.setHook('end', () => {
                csAni.clearHooks();
                res(true);
              });
              csAni.play();
            });
          };

          /**
           * 显示结束动画
           */
          this.cardFail = async () => {
            return new Promise(res => {
              this.homeSer.cardView.getController('failStatus').selectedIndex = 1;
              const csAni = this.homeSer.mainView.getTransition('cardFail');
              csAni.setHook('end', () => {
                csAni.clearHooks();
                this.homeSer.cardView.getController('failStatus').selectedIndex = 0;
                res(true);
              });
              csAni.play();
            });
          };

          /**
           * 将牌移动到历史列表中
           * @param toNode
           */
          this.moveTop = async () => {
            return new Promise(res => {
              let toIndex = this.homeSer.historySer.list.numItems - 1;
              if (toIndex > 7) toIndex = 7;
              const toNode = this.homeSer.historySer.hArr[toIndex];
              const cardView = this.homeSer.cardView;
              const mainView = this.homeSer.mainView;
              const bgBox = mainView.getChild('bg', fgui.GGraph);
              const toPos = toNode.localToGlobal(bgBox.x, bgBox.y);
              const {
                x,
                y
              } = cardView.node.position;
              cc.tween(cardView.node).to(0.6, {
                scale: new cc.Vec3(toNode.width / cardView.width, toNode.height / cardView.height, 1),
                position: new cc.Vec3(toPos.x + toNode.width / 2,
                /**
                 * 110：初始y坐标
                 * 210：初始y全局坐标 使用this.homeSer.historyView.localToGlobal(0, 0)获取
                 */
                -(this.homeSer.historyView.y - 110 + 210) + toNode.height / 2 + 5, 1)
              }, {
                easing: 'linear'
              }).call(() => {
                cardView.alpha = 0;
                cardView.node.setPosition(x, y, 1);
                cardView.node.setScale(1, 1, 1);
                res(true);
              }).start();
              mainView.getTransition('cardRotate').play();
            });
          };

          this.homeSer = homeSer;
        }

        onDestroy() {}

      });

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=84439bc9181a7867b904ffc8bfea35c8750fe3d3.js.map