System.register(["__unresolved_0", "cc", "tools-cocos3x"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _cc, Res, I18n, _crd, cc;

  function _reportPossibleCrUseOfRes(extras) {
    _reporterNs.report("Res", "tools-cocos3x", _context.meta, extras);
  }

  _export("I18n", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }, function (_toolsCocos3x) {
      Res = _toolsCocos3x.Res;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "1f938Ht4QJExa1MMoZPrKNx", "I18n", undefined);

      cc = __checkObsoleteInNamespace__(_cc);

      _export("I18n", I18n = class I18n {
        /** 初始化国际化配置 */
        static init(fun) {
          Object.defineProperty(cc.Node.prototype, 'addChild', {
            value: function (child) {
              I18n.setNodeLang(child); // @ts-ignore

              child.setParent(this);
            }
          });
          if (fun) fun();
        }
        /** 注册国际化节点 */


        static on(node) {
          const id = StrUtil.uuid();
          I18n.map[id] = node;
          return id;
        }
        /** 注销国际化节点 */


        static off(id) {
          delete I18n.map[id];
        }
        /** 注销所有国际化节点 */


        static clear() {
          I18n.map = {};
        }
        /** 获取多语言文本配置，可自定义配置获取方式，默认使用http获取 */


        static async getLangJson(lang) {
          try {
            let res = await http.get({
              url: '/lang/' + lang + '.json',
              timeout: 5000
            });
            if (typeof res === 'string') res = JSON.parse(res);
          } catch (error) {
            return undefined;
          }
        }
        /** 设置国际化节点 */


        static setNodeLang(node) {
          node.children.forEach(async child => {
            const text = child.getComponent(cc.Label);
            const sprite = child.getComponent(cc.Sprite);
            const audioSource = child.getComponent(cc.AudioSource);

            if (text) {
              if (!I18n.sourceMap[child.uuid]) {
                I18n.sourceMap[child.uuid] = {
                  text: text == null ? void 0 : text.string
                };
              }

              const _text = I18n.sourceMap[child.uuid].text;

              if (!I18n.langJson[I18n.lang]) {
                I18n.langJson[I18n.lang] = await I18n.getLangJson(I18n.lang);
              }

              if (I18n.langJson[I18n.lang]) {
                const _textstr = I18n.langJson[I18n.lang][_text];

                if (_textstr != text.string) {
                  text.string = _textstr;
                }
              }
            }

            if (sprite) {
              var _sprite$spriteFrame;

              const _uuid = (_sprite$spriteFrame = sprite.spriteFrame) == null ? void 0 : _sprite$spriteFrame.uuid;

              const info = I18n.resMap[_uuid];

              if (info) {
                let _path = info.path.split('/spriteFrame')[0];

                if (!I18n.sourceMap[child.uuid]) {
                  I18n.sourceMap[child.uuid] = {
                    text: _path
                  };
                }

                let _text = I18n.sourceMap[child.uuid].text;

                let _pathres = _text.split('/spriteFrame')[0];

                if (I18n.lang !== I18n.defaultLang) {
                  _pathres += '_' + I18n.lang;
                }

                _pathres += '/spriteFrame';

                const _spriteFrame = await (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                  error: Error()
                }), Res) : Res).getAsset(_pathres);

                if (_spriteFrame) sprite.spriteFrame = _spriteFrame;
              }
            }

            if (audioSource) {
              var _audioSource$clip;

              const _uuid = (_audioSource$clip = audioSource.clip) == null ? void 0 : _audioSource$clip.uuid;

              const info = I18n.resMap[_uuid];

              if (info) {
                let _path = info.path;

                if (!I18n.sourceMap[child.uuid]) {
                  I18n.sourceMap[child.uuid] = {
                    text: _path
                  };
                }

                let _text = I18n.sourceMap[child.uuid].text;

                if (I18n.lang !== I18n.defaultLang) {
                  _text += '_' + I18n.lang;
                }

                const _clip = await (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                  error: Error()
                }), Res) : Res).getAsset(_text);

                if (_clip) audioSource.clip = _clip;
              }
            }

            I18n.setNodeLang(child);
          });
        }
        /** 默认开发语言 */


        /** 设置语言 */
        static setLang(lang) {
          if (Object.keys(I18n.resMap).length == 0) {
            const keys = Object.keys((_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
              error: Error()
            }), Res) : Res).bundleMap);

            for (let i = 0; i < keys.length; i++) {
              var _bundleMap$key$_confi;

              const key = keys[i]; // @ts-ignore

              if ((_bundleMap$key$_confi = (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                error: Error()
              }), Res) : Res).bundleMap[key]._config) != null && (_bundleMap$key$_confi = _bundleMap$key$_confi.assetInfos) != null && _bundleMap$key$_confi._map) {
                var _bundleMap$key$_confi2;

                // @ts-ignore
                const _map = (_bundleMap$key$_confi2 = (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                  error: Error()
                }), Res) : Res).bundleMap[key]._config) == null || (_bundleMap$key$_confi2 = _bundleMap$key$_confi2.assetInfos) == null ? void 0 : _bundleMap$key$_confi2._map;

                const keys = Object.keys(_map);

                for (let j = 0; j < keys.length; j++) {
                  const _key = keys[j]; // @ts-ignore

                  I18n.resMap[_key] = _map[_key];
                }
              }
            }
          }

          I18n.lang = lang;
          Object.keys(I18n.map).forEach(key => {
            I18n.setNodeLang(I18n.map[key]);
          });
        }

      });

      I18n.langJson = {
        en: {
          title: 'Title',
          loading: 'Loading'
        },
        zh: {
          title: '标题',
          loading: '加载中'
        }
      };

      /** 资源数据备份 */
      I18n.resMap = {};

      /** 国际化节点 */
      I18n.map = {};

      /** 国际化节点原始数据 */
      I18n.sourceMap = {};
      I18n.defaultLang = 'en';

      /** 当前语言 */
      I18n.lang = 'en';

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=e57df043300e79416b0b0aa0c68fc7e2d29fe34b.js.map