System.register(["__unresolved_0", "cc", "__unresolved_1", "__unresolved_2"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _cc, Cocos3x, Res, Ci18n, _crd, cc;

  function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  function _reportPossibleCrUseOfCocos3x(extras) {
    _reporterNs.report("Cocos3x", "./Cocos3x", _context.meta, extras);
  }

  function _reportPossibleCrUseOfRes(extras) {
    _reporterNs.report("Res", "./Res", _context.meta, extras);
  }

  _export("Ci18n", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }, function (_unresolved_2) {
      Cocos3x = _unresolved_2.Cocos3x;
    }, function (_unresolved_3) {
      Res = _unresolved_3.Res;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "4bedfj32UpKRrGHax/KTr3o", "Ci18n", undefined);

      cc = __checkObsoleteInNamespace__(_cc);

      /**
       * 国际化管理
       * @param label 文本：在label上写入的值对应json的key
       * @param plist 图片：对应语言的plist、png后缀如：_zh、_en等
       * @param audio 音频：对应语言的mp3后缀如：_zh、_en等
       * @param skeleton 骨骼动画：对应语言的json、atlas、png后缀如：_zh、_en等
       */
      _export("Ci18n", Ci18n = class Ci18n {
        /** 初始化国际化配置 */
        static init(config) {
          /** 处理添加动态节点国际化 */
          Object.defineProperty(cc.Node.prototype, 'addChild', {
            value: function value(child) {
              Ci18n.setNodeLang(child); // @ts-ignore

              child.setParent(this);
            }
          });
          /** 重写加载方法，处理动态prefab国际化 */
          //@ts-ignore

          var _load = cc.assetManager.packManager.load;

          cc.assetManager.packManager.load = function (item, options, onComplete) {
            var _onComplete = onComplete;

            onComplete = (err, data) => {
              if (Ci18n.lang !== Ci18n.defaultLang) {
                var _item$info;

                //@ts-ignore
                var isPrefab = ((_item$info = item.info) == null ? void 0 : _item$info.ctor) == cc.Prefab;

                if (isPrefab) {
                  var findLangId = (path, type) => {
                    return Object.keys(Ci18n.resMap).find(key => Ci18n.resMap[key].path == path && Ci18n.resMap[key].ctor == type);
                  };

                  var fun = {
                    'Sprite': el => {
                      var _uuid = el._spriteFrame.__uuid__ || el._spriteFrame.uuid;

                      if (_uuid) {
                        var _info = Ci18n.resMap[_uuid];

                        if (_info) {
                          if (_info.path.endsWith('/spriteFrame')) {
                            var _sp = _info.path.split('/spriteFrame');

                            _uuid = findLangId(_sp[0] + '_' + Ci18n.lang + '/spriteFrame', cc.SpriteFrame);
                          } else {
                            var psfurl1 = _info.path.substring(0, _info.path.lastIndexOf('/'));

                            var psfurl2 = _info.path.substring(_info.path.lastIndexOf('/'));

                            _uuid = findLangId(psfurl1 + '_' + Ci18n.lang + psfurl2, cc.SpriteFrame);
                          }

                          el._spriteFrame.uuid = _uuid;
                          el._spriteFrame.__uuid__ = _uuid;
                        }
                      }

                      return el;
                    },
                    'Skeleton': el => {
                      var _uuid = el._skeletonData.__uuid__ || el._skeletonData.uuid;

                      if (_uuid) {
                        var _info = Ci18n.resMap[_uuid];

                        if (_info) {
                          _uuid = findLangId(_info.path + '_' + Ci18n.lang, cc.sp.SkeletonData);
                          el._skeletonData.__uuid__ = _uuid;
                          el._skeletonData.uuid = _uuid;
                        }
                      }

                      return el;
                    }
                  };

                  if (Array.isArray(data)) {
                    for (var j = 0; j < data.length; j++) {
                      var el = data[j];

                      if (el._spriteFrame) {
                        fun['Sprite'](el);
                      } else if (el._skeletonData) {
                        fun['Skeleton'](el);
                      }
                    }
                  }
                }
              }

              _onComplete(err, data);
            }; //@ts-ignore


            return _load.call(cc.assetManager.packManager, item, options, onComplete);
          };

          Ci18n.lang = config.lang;
          Ci18n.defaultLang = config.defaultLang;
          Ci18n.langList = config.langList.map(item => '_' + item);
        }
        /** 注册国际化节点 */


        static on(node) {
          var id = StrUtil.uuid();
          Ci18n.map[id] = node;
          Ci18n.setNodeLang(node);
          return id;
        }
        /** 注销国际化节点 */


        static off(id) {
          delete Ci18n.map[id];
        }
        /** 注销所有国际化节点 */


        static clear() {
          Ci18n.map = {};
        }
        /** 获取多语言文本配置，可自定义配置获取方式，默认使用http获取 */


        static getLangJson(lang) {
          return _asyncToGenerator(function* () {
            try {
              if (Ci18n.langJson[lang]) return Ci18n.langJson[lang];
              var res = yield http.get({
                url: '/lang/' + lang + '.json',
                timeout: 5000
              });
              if (typeof res === 'string') res = JSON.parse(res);
              Ci18n.langJson[lang] = res;
              return res;
            } catch (error) {
              return undefined;
            }
          })();
        }
        /** 设置国际化节点 */


        static setNodeLang(node) {
          return _asyncToGenerator(function* () {
            var updateNodeLang = /*#__PURE__*/function () {
              var _ref = _asyncToGenerator(function* (child) {
                var text = child.getComponent(cc.Label);
                var sprite = child.getComponent(cc.Sprite);
                var audioSource = child.getComponent(cc.AudioSource);
                var skeleton = child.getComponent(cc.sp.Skeleton);

                try {
                  if (text) {
                    if (!Ci18n.sourceMap[child.uuid]) Ci18n.sourceMap[child.uuid] = {
                      text: text.string
                    };
                    var _text = Ci18n.sourceMap[child.uuid].text;
                    var langJson = yield Ci18n.getLangJson(Ci18n.lang);

                    if (langJson) {
                      var val = ObjectUtil.getPathValue(langJson, _text);
                      if (val !== text.string) text.string = val;
                    }
                  }

                  if (sprite) {
                    var _sprite$spriteFrame;

                    var _uuid = (_sprite$spriteFrame = sprite.spriteFrame) == null ? void 0 : _sprite$spriteFrame.uuid;

                    var info = Ci18n.resMap[_uuid];

                    if (info) {
                      var _path = info.path.split('/spriteFrame')[0];

                      if (!Ci18n.sourceMap[child.uuid]) {
                        var _info = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                          error: Error()
                        }), Cocos3x) : Cocos3x).Ci18n.pathInList(_path);

                        if (_info.status) _path = _path.replace((_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                          error: Error()
                        }), Cocos3x) : Cocos3x).Ci18n.langList[_info.index], '');
                        Ci18n.sourceMap[child.uuid] = {
                          text: _path
                        };
                      }

                      var _text2 = Ci18n.sourceMap[child.uuid].text; //获取plist下的spriteFrame

                      var psfurl = _text2.split('/spriteFrame')[0];

                      var psfurl1 = psfurl.substring(0, psfurl.lastIndexOf('/'));
                      var psfurl2 = psfurl.substring(psfurl.lastIndexOf('/'));
                      if (Ci18n.lang !== Ci18n.defaultLang) psfurl = psfurl1 + '_' + Ci18n.lang + psfurl2;

                      var _pssf = yield (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                        error: Error()
                      }), Res) : Res).getAsset(psfurl, cc.SpriteFrame, info.bundleName);

                      if (_pssf instanceof cc.SpriteFrame) {
                        sprite.spriteFrame = _pssf;
                      } else {
                        //尝试获取图片下的spriteFrame
                        var _pathres = _text2.split('/spriteFrame')[0];

                        if (Ci18n.lang !== Ci18n.defaultLang) {
                          _pathres += '_' + Ci18n.lang;
                        }

                        _pathres += '/spriteFrame';

                        var _spriteFrame = yield (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                          error: Error()
                        }), Res) : Res).getAsset(_pathres, cc.SpriteFrame, info.bundleName);

                        if (_spriteFrame instanceof cc.SpriteFrame) sprite.spriteFrame = _spriteFrame;
                      }
                    }
                  }

                  if (audioSource) {
                    var _audioSource$clip;

                    var _uuid2 = (_audioSource$clip = audioSource.clip) == null ? void 0 : _audioSource$clip.uuid;

                    var _info2 = Ci18n.resMap[_uuid2];

                    if (_info2) {
                      var _path2 = _info2.path;

                      if (!Ci18n.sourceMap[child.uuid]) {
                        var _info3 = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                          error: Error()
                        }), Cocos3x) : Cocos3x).Ci18n.pathInList(_path2);

                        if (_info3.status) _path2 = _path2.replace((_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                          error: Error()
                        }), Cocos3x) : Cocos3x).Ci18n.langList[_info3.index], '');
                        Ci18n.sourceMap[child.uuid] = {
                          text: _path2
                        };
                      }

                      var _text3 = Ci18n.sourceMap[child.uuid].text;

                      if (Ci18n.lang !== Ci18n.defaultLang) {
                        _text3 += '_' + Ci18n.lang;
                      }

                      var _clip = yield (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                        error: Error()
                      }), Res) : Res).getAsset(_text3, cc.AudioClip, _info2.bundleName);

                      if (_clip) audioSource.clip = _clip;
                    }
                  }

                  if (skeleton) {
                    var _skeleton$skeletonDat;

                    var _uuid3 = (_skeleton$skeletonDat = skeleton.skeletonData) == null ? void 0 : _skeleton$skeletonDat.uuid;

                    var _info4 = Ci18n.resMap[_uuid3];

                    if (_info4) {
                      var _path3 = _info4.path;

                      if (!Ci18n.sourceMap[child.uuid]) {
                        var _info5 = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                          error: Error()
                        }), Cocos3x) : Cocos3x).Ci18n.pathInList(_path3);

                        if (_info5.status) _path3 = _path3.replace((_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                          error: Error()
                        }), Cocos3x) : Cocos3x).Ci18n.langList[_info5.index], '');
                        Ci18n.sourceMap[child.uuid] = {
                          text: _path3
                        };
                      }

                      var _text4 = Ci18n.sourceMap[child.uuid].text;

                      if (Ci18n.lang !== Ci18n.defaultLang) {
                        _text4 += '_' + Ci18n.lang;
                      }

                      var _skeletonData = yield (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                        error: Error()
                      }), Res) : Res).getAsset(_text4, cc.sp.SkeletonData, _info4.bundleName);

                      if (_skeletonData) {
                        var _aniName = skeleton.animation;
                        var _loop = skeleton.loop;
                        skeleton.skeletonData = _skeletonData;
                        skeleton.setAnimation(0, _aniName, _loop);
                      }
                    }
                  }
                } catch (error) {
                  console.log('error', error);
                }

                for (var i = 0; i < child.children.length; i++) {
                  var _child = child.children[i];
                  updateNodeLang(_child);
                }
              });

              return function updateNodeLang(_x) {
                return _ref.apply(this, arguments);
              };
            }();

            updateNodeLang(node);
          })();
        }
        /** 默认开发语言-不带后缀 */


        /** 由Res调用加载资源映射 */
        static loadResMap(key) {
          var _bundleMap$key$_confi;

          // @ts-ignore
          var map = (_bundleMap$key$_confi = (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
            error: Error()
          }), Res) : Res).bundleMap[key]._config) == null || (_bundleMap$key$_confi = _bundleMap$key$_confi.assetInfos) == null ? void 0 : _bundleMap$key$_confi._map;

          if (map) {
            Object.keys(map).forEach(_key => {
              Ci18n.resMap[_key] = _extends({}, map[_key], {
                bundleName: key
              });
            });
          }
        }
        /** 设置语言 */


        static setLang(lang) {
          return _asyncToGenerator(function* () {
            if (Ci18n.lang === lang) return;
            Ci18n.lang = lang;
            var keys = Object.keys(Ci18n.map);

            for (var i = 0; i < keys.length; i++) {
              var _key2 = keys[i];
              Ci18n.setNodeLang(Ci18n.map[_key2]);
            }
          })();
        }
        /** 判断路径是否包含语言后缀 */


        static pathInList(path) {
          var langList = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
            error: Error()
          }), Cocos3x) : Cocos3x).Ci18n.langList;

          for (var i = 0; i < langList.length; i++) {
            if (path.indexOf(langList[i]) !== -1) {
              return {
                status: true,
                index: i
              };
            }
          }

          return {
            status: false,
            index: -1
          };
        }

      });

      /**
       * 语言json
       */
      Ci18n.langJson = {};

      /** 国际化节点 */
      Ci18n.map = {};

      /** 国际化节点原始数据 */
      Ci18n.sourceMap = {};
      Ci18n.defaultLang = 'en';

      /** 当前语言 */
      Ci18n.lang = 'en';

      /**
       * 支持的语言列表
       */
      Ci18n.langList = [];

      /** 资源数据备份 */
      Ci18n.resMap = {};
      (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
        error: Error()
      }), Cocos3x) : Cocos3x).Ci18n = Ci18n;

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=347f6a60338765f84b525e59e16ca114b995eedc.js.map