System.register(["__unresolved_0", "cc", "__unresolved_1"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _cc, Cocos3x, Res, _crd, cc;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  function _reportPossibleCrUseOfCocos3x(extras) {
    _reporterNs.report("Cocos3x", "./Cocos3x", _context.meta, extras);
  }

  _export("Res", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }, function (_unresolved_2) {
      Cocos3x = _unresolved_2.Cocos3x;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "f6c8eaUkZZBdoYu4qwg1T2q", "Res", undefined);

      cc = __checkObsoleteInNamespace__(_cc);

      /**
       * 资源管理
       * @param i18n loadBundle支持国际化，如果配置了i18n，则只会加载对应语言的资源
       */
      _export("Res", Res = class Res {
        /**
         * 获取资源
         * @param bundleName 资源包名
         * @param assetName 资源名
         * @returns 资源
         */
        static getAsset(assetName, //@ts-ignore
        type, bundleName) {
          if (type === void 0) {
            type = null;
          }

          if (bundleName === void 0) {
            bundleName = Res.bundleName;
          }

          return new Promise((resolve, reject) => {
            Res.bundleMap[bundleName].load(assetName, type, (err, asset) => {
              resolve(asset);
            });
          });
        }
        /** 是否支持国际化，默认开启，以当前语言作为Bundle的加载列表 */


        /**
         * 加载单个资源包
         * @param bundleName 资源包名
         * @returns 资源包
         */
        static loadBundle(bundleName, config) {
          return new Promise((resolve, reject) => {
            var totalTime = Date.now();
            cc.assetManager.loadBundle(bundleName, function (err, bundle) {
              Res.bundleMap[bundleName] = bundle;

              var _dir = bundle.getDirWithPath(''); // 过滤资源


              if (config != null && config.pathList) {
                _dir = _dir.filter(item => config.pathList.find(path => path.startsWith(item.path)));
              } // 国际化支持


              if (Res.i18n) {
                var tlang = (config == null ? void 0 : config.lang) || (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                  error: Error()
                }), Cocos3x) : Cocos3x).Ci18n.lang;

                var langall = _dir.map(item => {
                  var _info = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                    error: Error()
                  }), Cocos3x) : Cocos3x).Ci18n.pathInList(item.path);

                  if (_info.status) {
                    return item.path.split((_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                      error: Error()
                    }), Cocos3x) : Cocos3x).Ci18n.langList[_info.index])[0];
                  }

                  return null;
                }).filter(item => item);

                langall = langall.filter((item, index, self) => self.indexOf(item) === index);
                _dir = _dir.filter(item => {
                  for (var i = 0; i < langall.length; i++) {
                    if (item.path.startsWith(langall[i])) {
                      if ((_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                        error: Error()
                      }), Cocos3x) : Cocos3x).Ci18n.defaultLang === tlang) {
                        var _info = (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                          error: Error()
                        }), Cocos3x) : Cocos3x).Ci18n.pathInList(item.path);

                        if (_info.status) return false;
                        return true;
                      } else if (item.path.indexOf('_' + tlang) !== -1) {
                        return true;
                      }

                      return false;
                    }
                  }

                  return true;
                });
              } // 自定义资源路径


              if (config != null && config.dirCallback) {
                _dir = config.dirCallback(_dir);
              } // 区分prefab和其他资源


              var prefabArr = [];
              var otherArr = [];

              for (var i = 0; i < _dir.length; i++) {
                var item = _dir[i];

                if (item.ctor == cc.Prefab) {
                  prefabArr.push(item);
                } else {
                  otherArr.push(item);
                }
              } // 资源总数


              var total = _dir.length; // 加载数量

              var loaded = 0; // 加载进度处理和回调

              var _callback = (_info, fun) => {
                loaded++;
                var progress = loaded / total * 100;

                var _totalTime = Date.now() - totalTime;

                var _res = {
                  bundle,
                  dir: _dir,
                  info: _info,
                  totalTime: _totalTime,
                  bundleName,
                  progress
                };
                if (config != null && config.onProgress) config.onProgress(_res);
                if (fun) fun(loaded, progress);

                if (progress === 100) {
                  (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                    error: Error()
                  }), Cocos3x) : Cocos3x).Ci18n.loadResMap(bundleName);
                  resolve(true);
                }
              };

              var loadPrefab = () => {
                if (!prefabArr.length) return;
                (_crd && Cocos3x === void 0 ? (_reportPossibleCrUseOfCocos3x({
                  error: Error()
                }), Cocos3x) : Cocos3x).Ci18n.loadResMap(bundleName);

                var _loop = function _loop() {
                  var _info = prefabArr[_i];
                  bundle.load(_info.path, (err, asset) => {
                    _callback(_info);
                  });
                };

                for (var _i = 0; _i < prefabArr.length; _i++) {
                  _loop();
                }
              };

              var _loop2 = function _loop2() {
                var _info = otherArr[_i2];
                bundle.load(_info.path, (err, asset) => {
                  _callback(_info, (_loaded, progress) => {
                    if (_loaded === otherArr.length) loadPrefab();
                  });
                });
              };

              for (var _i2 = 0; _i2 < otherArr.length; _i2++) {
                _loop2();
              }
            });
          });
        }
        /**
         * 加载资源包
         * @param bundleName 资源包名
         * @returns 资源包
         */


        static loadBundles(bundleNames, config) {
          return new Promise( /*#__PURE__*/_asyncToGenerator(function* (resolve, reject) {
            for (var i = 0; i < bundleNames.length; i++) {
              var bundleName = bundleNames[i];
              yield Res.loadBundle(bundleName, config);
            }

            resolve(true);
          }));
        }

      });

      /**
       * 资源包
       */
      Res.bundleMap = {};

      /**
       * 全局默认资源包名
       */
      Res.bundleName = 'home';
      Res.i18n = true;

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=c09ebc76ce7e60c980a00788b290165c15f73568.js.map