System.register(["__unresolved_0", "cc", "tools-cocos3x"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, __checkObsolete__, __checkObsoleteInNamespace__, _cc, Res, I18n, _crd, cc;

  function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

  function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

  function _reportPossibleCrUseOfRes(extras) {
    _reporterNs.report("Res", "tools-cocos3x", _context.meta, extras);
  }

  _export("I18n", void 0);

  return {
    setters: [function (_unresolved_) {
      _reporterNs = _unresolved_;
    }, function (_cc2) {
      _cclegacy = _cc2.cclegacy;
      __checkObsolete__ = _cc2.__checkObsolete__;
      __checkObsoleteInNamespace__ = _cc2.__checkObsoleteInNamespace__;
      _cc = _cc2;
    }, function (_toolsCocos3x) {
      Res = _toolsCocos3x.Res;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "1f938Ht4QJExa1MMoZPrKNx", "I18n", undefined);

      cc = __checkObsoleteInNamespace__(_cc);

      _export("I18n", I18n = class I18n {
        /** 初始化国际化配置 */
        static init(fun) {
          Object.defineProperty(cc.Node.prototype, 'addChild', {
            value: function value(child) {
              I18n.setNodeLang(child); // @ts-ignore

              child.setParent(this);
            }
          });
          if (fun) fun();
        }
        /** 注册国际化节点 */


        static on(node) {
          var id = StrUtil.uuid();
          I18n.map[id] = node;
          return id;
        }
        /** 注销国际化节点 */


        static off(id) {
          delete I18n.map[id];
        }
        /** 注销所有国际化节点 */


        static clear() {
          I18n.map = {};
        }
        /** 获取多语言文本配置，可自定义配置获取方式，默认使用http获取 */


        static getLangJson(lang) {
          return _asyncToGenerator(function* () {
            try {
              var res = yield http.get({
                url: '/lang/' + lang + '.json',
                timeout: 5000
              });
              if (typeof res === 'string') res = JSON.parse(res);
            } catch (error) {
              return undefined;
            }
          })();
        }
        /** 设置国际化节点 */


        static setNodeLang(node) {
          node.children.forEach( /*#__PURE__*/_asyncToGenerator(function* (child) {
            var text = child.getComponent(cc.Label);
            var sprite = child.getComponent(cc.Sprite);
            var audioSource = child.getComponent(cc.AudioSource);

            if (text) {
              if (!I18n.sourceMap[child.uuid]) {
                I18n.sourceMap[child.uuid] = {
                  text: text == null ? void 0 : text.string
                };
              }

              var _text = I18n.sourceMap[child.uuid].text;

              if (!I18n.langJson[I18n.lang]) {
                I18n.langJson[I18n.lang] = yield I18n.getLangJson(I18n.lang);
              }

              if (I18n.langJson[I18n.lang]) {
                var _textstr = I18n.langJson[I18n.lang][_text];

                if (_textstr != text.string) {
                  text.string = _textstr;
                }
              }
            }

            if (sprite) {
              var _sprite$spriteFrame;

              var _uuid = (_sprite$spriteFrame = sprite.spriteFrame) == null ? void 0 : _sprite$spriteFrame.uuid;

              var info = I18n.resMap[_uuid];

              if (info) {
                var _path = info.path.split('/spriteFrame')[0];

                if (!I18n.sourceMap[child.uuid]) {
                  I18n.sourceMap[child.uuid] = {
                    text: _path
                  };
                }

                var _text2 = I18n.sourceMap[child.uuid].text;

                var _pathres = _text2.split('/spriteFrame')[0];

                if (I18n.lang !== I18n.defaultLang) {
                  _pathres += '_' + I18n.lang;
                }

                _pathres += '/spriteFrame';

                var _spriteFrame = yield (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                  error: Error()
                }), Res) : Res).getAsset(_pathres);

                if (_spriteFrame) sprite.spriteFrame = _spriteFrame;
              }
            }

            if (audioSource) {
              var _audioSource$clip;

              var _uuid2 = (_audioSource$clip = audioSource.clip) == null ? void 0 : _audioSource$clip.uuid;

              var _info = I18n.resMap[_uuid2];

              if (_info) {
                var _path2 = _info.path;

                if (!I18n.sourceMap[child.uuid]) {
                  I18n.sourceMap[child.uuid] = {
                    text: _path2
                  };
                }

                var _text3 = I18n.sourceMap[child.uuid].text;

                if (I18n.lang !== I18n.defaultLang) {
                  _text3 += '_' + I18n.lang;
                }

                var _clip = yield (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                  error: Error()
                }), Res) : Res).getAsset(_text3);

                if (_clip) audioSource.clip = _clip;
              }
            }

            I18n.setNodeLang(child);
          }));
        }
        /** 默认开发语言 */


        /** 设置语言 */
        static setLang(lang) {
          if (Object.keys(I18n.resMap).length == 0) {
            var keys = Object.keys((_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
              error: Error()
            }), Res) : Res).bundleMap);

            for (var i = 0; i < keys.length; i++) {
              var _bundleMap$_key2$_con;

              var _key2 = keys[i]; // @ts-ignore

              if ((_bundleMap$_key2$_con = (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                error: Error()
              }), Res) : Res).bundleMap[_key2]._config) != null && (_bundleMap$_key2$_con = _bundleMap$_key2$_con.assetInfos) != null && _bundleMap$_key2$_con._map) {
                var _bundleMap$_key2$_con2;

                // @ts-ignore
                var _map = (_bundleMap$_key2$_con2 = (_crd && Res === void 0 ? (_reportPossibleCrUseOfRes({
                  error: Error()
                }), Res) : Res).bundleMap[_key2]._config) == null || (_bundleMap$_key2$_con2 = _bundleMap$_key2$_con2.assetInfos) == null ? void 0 : _bundleMap$_key2$_con2._map;

                var _keys = Object.keys(_map);

                for (var j = 0; j < _keys.length; j++) {
                  var _key = _keys[j]; // @ts-ignore

                  I18n.resMap[_key] = _map[_key];
                }
              }
            }
          }

          I18n.lang = lang;
          Object.keys(I18n.map).forEach(key => {
            I18n.setNodeLang(I18n.map[key]);
          });
        }

      });

      I18n.langJson = {
        en: {
          title: 'Title',
          loading: 'Loading'
        },
        zh: {
          title: '标题',
          loading: '加载中'
        }
      };

      /** 资源数据备份 */
      I18n.resMap = {};

      /** 国际化节点 */
      I18n.map = {};

      /** 国际化节点原始数据 */
      I18n.sourceMap = {};
      I18n.defaultLang = 'en';

      /** 当前语言 */
      I18n.lang = 'en';

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=e57df043300e79416b0b0aa0c68fc7e2d29fe34b.js.map